/**
  * @author Everis
  * @since February 11, 2019
  * @desc Utility class for the methods of the Global Solution Model (GSM)
  * @history February 11, 2019 - everis (JVC) - Create Apex Class
  */
  public without sharing class FII_Util_GSM {

	// RecordTypeId of the record types used
	private static final Id IDRT_CAS_NEED = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_NEED).Id;
	private static final Id IDRT_CAS_CLOSEDNEED = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_CLOSEDNEED).Id;
	private static final Id IDRT_CAS_ACTION = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_ACTION).Id;
	private static final Id IDRT_CAS_CLAIM = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_CLAIM).Id;
	private static final Id IDRT_CAS_CLOSEDCLAIM = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_CLOSEDCLAIM).Id;
	private static final Id IDRT_ACT_INTERACTION = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_TSK_INTERACTION).Id;
	private static final Id IDRT_ACT_ACTION = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_TSK_ACTION).Id;
	private static final Id IDRT_ACT_PAYMENT_AGREEMENT = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_TSK_PAYMENT_AGREEMENT).Id;
	private static final Id IDRT_ACT_OBLIGATION_REMITTANCE = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_TSK_OBLIGATION_REMITTANCE).Id;
	private static final Id IDRT_ACT_PROVIDE_CONSUMPTIONS = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_TSK_PROVIDE_CONSUMPTIONS).Id;
	private static final Id IDRT_ACT_URL_PAID = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_TSK_URL_PAID).Id;
	private static final Id IDRT_ACT_CARD_PAYMENT = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_TSK_CARD_PAYMENT).Id;
	private static final Id IDRT_CAS_ADMIN_GESTION = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_ADMINGESTION).Id;
	private static final Id IDRT_ACT_PAYMENT_REQUESTED = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_TSK_PaymentRequested).Id;
	private static final Id IDRT_ACT_CARD_PAYMENT_REQUESTED = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_TSK_CardPaymentRequested).Id;
	
	// RecordTypeId of CCDD cases
	private static final Id IDRT_CAS_CHAT = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_CHAT).Id;
	private static final Id IDRT_CAS_EMAIL = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_EMAIL).Id;
	private static final Id IDRT_CAS_OUTEMAIL = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_OUTMAIL).Id;
	private static final Id IDRT_CAS_DISSATISFACTION = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_DISSATISFACTION).Id;
	private static final Id IDRT_CAS_SOCIAL = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_SOCIAL).Id;
	private static final Id IDRT_CAS_FACEBOOK = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_FACEBOOK).Id;
	private static final Id IDRT_CAS_MESSENGER = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_MESSENGER).Id;
	private static final Id IDRT_CAS_SOCIALRT = FII_Util_MasterData_RecordTypes.getByDevName(Label.FII_RT_CAS_SOCIALRT).Id;

	// List of RecordtypesId with same tratament
	private static final List<String> CAS_NEEDS_RT = new List<String>{IDRT_CAS_NEED, IDRT_CAS_CLOSEDNEED};
	private static final List<String> ACT_ACTIONS_RT = new List<String>{IDRT_ACT_ACTION, IDRT_ACT_PAYMENT_AGREEMENT, IDRT_ACT_OBLIGATION_REMITTANCE, IDRT_ACT_PROVIDE_CONSUMPTIONS, IDRT_ACT_URL_PAID, IDRT_ACT_CARD_PAYMENT, IDRT_ACT_PAYMENT_REQUESTED, IDRT_ACT_CARD_PAYMENT_REQUESTED};
	private static final List<String> CAS_ACTIONS_RT = new List<String>{IDRT_CAS_ACTION, IDRT_CAS_CLAIM, IDRT_CAS_CLOSEDCLAIM, IDRT_CAS_CHAT, IDRT_CAS_EMAIL, IDRT_CAS_OUTEMAIL, IDRT_CAS_DISSATISFACTION, IDRT_CAS_SOCIAL, IDRT_CAS_FACEBOOK, IDRT_CAS_MESSENGER, IDRT_CAS_SOCIALRT, IDRT_CAS_ADMIN_GESTION};

	/********************
	 * CREATION METHODS *
	 ********************/

	/**
	 * Returns a new Need of cliente
	 *
	 * @param recId: 
	 * @param interactionInProgress: 
	 * @param actionType: type of the new action
	 * @param actionSubtype: subtype of the new action
	 * @param subject: subject of the new need and new action
	 * @param camId: Id of campaign related to the new need
	 * @param status: status of the new action
	 * @param recordtype: recordtype of the new action
	 * @return a new need related with input params
	 */
    public static List<SObject> standardBehaviorGSM(Id recId, String actionType, String actionSubtype, String subjectNeed, String subjectAct, Id camId, String status, String recordtype){
    	return standardBehaviorGSM(recId, actionType, actionSubtype, subjectNeed, subjectAct, camId, status, recordtype, false);       
    }   
    
    public static List<SObject> standardBehaviorGSM(Id recId, String actionType, String actionSubtype, String subjectNeed, String subjectAct, Id camId, String status, String recordtype, Boolean acceptComm){
        //Creating the DMLOptions for "Assign using active assignment rules" checkbox
		Database.DMLOptions dmlOpts = new Database.DMLOptions();
		if (Schema.sObjectType.AssignmentRule.isAccessible()) {
			//Fetching the assignment rules on case
			final AssignmentRule rule= [SELECT Id FROM AssignmentRule WHERE SobjectType = 'Case' AND Active = true LIMIT 1];
			dmlOpts.assignmentRuleHeader.assignmentRuleId= rule.id;
		}

		Id clientId = null;
		Id leadId = null;
		Id needId = null;
		List<SObject> needAndAction = new List<SObject>();
		Boolean createNeed = true;
		
		switch on String.valueOf(recId.getSobjectType()){
			when 'Account' {
				clientId = recId;
			}
			when 'Case' {
				createNeed = false;
				needId = recId;
			}
			when 'Lead' {
				leadId = recId;
			}
			when 'Contact' {
				final Task interactionInProgress = getInteractionInProgress(recId);
				if (interactionInProgress != null) {
					clientId = interactionInProgress.FII_ACT_LKP_RelatedClient__c;
				}
				else {
					if(Schema.sObjectType.Contact.isAccessible()){
						final Contact cont = [SELECT AccountId FROM Contact WHERE Id =: recId][0];
						clientId = cont.AccountId;
					}
				}
				
			}
			when 'B2C_Address__c'{
				if(Schema.sObjectType.B2C_Address__c.isAccessible()){
					final B2C_Address__c cd= [SELECT Account__c FROM B2C_Address__c WHERE Id=:recId][0];
					clientId = cd.Account__c;
				}
			}
		}

		if(createNeed){
			final Case need = createNeed(clientId, leadId, subjectNeed, camId);
			if(Schema.sObjectType.Case.isCreateable()){
				insert need;
				needId = need.Id;
			}
		}
		final Case c = (Case)consultRecordPrimary(needId);
		needAndAction.add(c);
		
		if(!createNeed){
			clientId = c.AccountId;
			leadId = c.Lead__c;
		}
		if(recordtype == Label.FII_RT_CAS_ACTION || recordtype == Label.FII_RT_CAS_ADMINGESTION){
            final Case actionCase;
            if(acceptComm == true){
                actionCase = createCaseAction(needId, clientId, leadId, actionType, actionSubtype, subjectAct, status, recordtype, acceptComm);
            }else{
            	actionCase = createCaseAction(needId, clientId, leadId, actionType, actionSubtype, subjectAct, status, recordtype);    
            }
			actionCase.setOptions(dmlOpts);
			if(Schema.sObjectType.Case.isCreateable()){
				insert actionCase;
				needAndAction.add(actionCase);
			}
		} else{
			final Task actionTask = createTaskAction(c, subjectAct, status, recordtype);
			if(Schema.sObjectType.Task.isCreateable()){
				insert actionTask;
				needAndAction.add(actionTask);
			}
		}
		return needAndAction;
	}

	/**
	 * Returns a new Need of cliente
	 *
	 * @param clientId: Id of client (if required) related to the need
	 * @param contactId: Id of contact (if required) related to the need
	 * @param leadId: Id of lead (if required) related to the need
	 * @param channel: channel of the need
	 * @param subject: subject of the need
	 * @param status: status of the need
	 * @param camId: Id of campaign related to the need
	 * @return a new need related with input params
	 */
	public static Case createNeed(Id clientId, Id leadId, String subject, Id camId){
		Case need = new Case();
		if(leadId != null){
			need.Lead__c = leadId;
		} else{
			need.AccountId = clientId;
		}
		need.RecordTypeId = IDRT_CAS_NEED;
		need.Subject = subject;
		need.Status = Label.FII_CaseStatus_New;
		need.FII_CAS_LKP_Campaign__c = camId;
		return need;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
    
    public static Case createCaseAction(Id parentId, Id clientId, Id leadId, String actionType, String actionSubtype, String subject, String status, String recordtype){
        return createCaseAction(parentId, clientId, leadId, actionType, actionSubtype, subject, status, recordtype, false);
    }
    
    public static Case createCaseAction(Id parentId, Id clientId, Id leadId, String actionType, String actionSubtype, String subject, String status, String recordtype, Boolean acceptComm){
        Case caseAction = new Case();
		if(leadId != null){
			caseAction.Lead__c = leadId;
		} else{
			caseAction.AccountId = clientId;
		}
		if(recordtype == Label.FII_RT_CAS_ACTION) {
			caseAction.RecordTypeId = IDRT_CAS_ACTION;
		} else if(recordtype == Label.FII_RT_CAS_ADMINGESTION){
			caseAction.RecordTypeId = IDRT_CAS_ADMIN_GESTION;
		} else if(recordtype == Label.FII_RT_CAS_EMAIL){
            caseAction.RecordTypeId = IDRT_CAS_EMAIL;
        }

		caseAction.ParentId = parentId;
		caseAction.Type = actionType;
		caseAction.FII_CAS_SEL_Subtype__c = actionSubtype;
		caseAction.Subject = subject;
		caseAction.Status = status;
        caseAction.FII_CAS_FLG_SendNoticeInvoice__c = acceptComm;
        caseAction.F2B_CAS_FLG_ViewSendNoticeInvoice__c = !acceptComm;
		return caseAction;
    }

	/**
	 * Returns an action to insert
	 *
	 * @param c: need in which the action is performed.
	 * @param interactionInProgress: interaction in progress through which the action is required
	 * @param subject: subject of the action
	 * @param status: status of the action
	 * @param recordtype: recordtype of the action
	 *      input values alowed:
	 *          Label.FII_RT_TSK_ACTION
	 *          Label.FII_RT_TSK_PAYMENT_AGREEMENT
	 *          Label.FII_RT_TSK_OBLIGATION_REMITTANCE
	 *          Label.FII_RT_TSK_PROVIDE_CONSUMPTIONS
	 *          Label.FII_RT_TSK_URL_PAID
	 * @return action to insert
	 */
	public static Task createTaskAction(Case c, String subject, String status, String recordtype){
		Task action = new Task();
		// Depending on the recordtype we fill in the following fields
		// A switch-case is not used because it does not support final variables (labels)
		if(recordtype == Label.FII_RT_TSK_ACTION) {
			action.RecordTypeId = IDRT_ACT_ACTION;
			action.Type = Label.FII_TaskType_Action;
		} else if(recordtype == Label.FII_RT_TSK_PAYMENT_AGREEMENT){
			action.RecordTypeId = IDRT_ACT_PAYMENT_AGREEMENT;
			action.Type = Label.FII_TaskType_Business;
		} else if(recordtype == Label.FII_RT_TSK_OBLIGATION_REMITTANCE){
			action.RecordTypeId = IDRT_ACT_OBLIGATION_REMITTANCE;
			action.Type = Label.FII_TaskType_Business;
		} else if(recordtype == Label.FII_RT_TSK_CARD_PAYMENT){
			action.RecordTypeId = IDRT_ACT_CARD_PAYMENT;
			action.Type = Label.FII_TaskType_Business;
			action.FII_ACT_SEL_SubTipoTarea__c = Label.FII_TaskSubtype_PagoTarjeta;
		} else if(recordtype == Label.FII_RT_TSK_PROVIDE_CONSUMPTIONS){
			action.RecordTypeId = IDRT_ACT_PROVIDE_CONSUMPTIONS;
			action.Type = Label.FII_TaskType_Business;
		} else if(recordtype == Label.FII_RT_TSK_URL_PAID){
			action.RecordTypeId = IDRT_ACT_URL_PAID;
			action.Type = Label.FII_TaskType_Business;
		}

		// The rest of fields
		action.Subject = subject;
		action.Status = status;
		action.FII_ACT_LKP_Campaign__c = c.FII_CAS_LKP_Campaign__c;
		if(c.Lead__c != null){
			action.FII_ACT_LKP_WhatId__c = c.Id;
			action.WhoId = c.Lead__c;
		} else{
			action.WhatId = c.Id;
			action.FII_ACT_LKP_RelatedClient__c = c.AccountId;
		}
		return action;
	}


	/**
	 * Returns an interaction that is not yet related to any need or action
	 *
	 * @param clientId: Id of client (if required) related to interaction
	 * @param contactId: Id of contact (if required) related to interaction
	 * @param leadId: Id of lead (if required) related to interaction
	 * @param channel: channel of the interaction
	 * @param subject: subject of the interaction
	 * @return a new interaction related with input params
	 */
	public static Task createInteraction(Id clientId, Id contactId, Id leadId, String channel, String subject){
		Task interaction = new Task();
		if(leadId != null){
			interaction.WhoId = leadId;
			interaction.TV_ACT_LKP_LeadID__c = leadId;
		}else{
			if(contactId != null){
				interaction.WhoId = contactId;
				if(Schema.sObjectType.AccountContactRelation.isAccessible()){
					final List<AccountContactRelation> acrs = [SELECT Roles FROM AccountContactRelation WHERE AccountId = :clientId AND ContactId = :contactId];
					String role = '';
					if(acrs.size()>0){
						role = acrs[0].Roles;
					}
					interaction.FII_ACT_TXT_Role__c = role;
				}
			}

			interaction.FII_ACT_LKP_RelatedClient__c = clientId;
		}
		interaction.OwnerId = UserInfo.getUserId();
		interaction.Type = Label.FII_TaskType_Interaction;
		interaction.Subject = 'Interacción: '+ subject;
		interaction.FII_ACT_SEL_Channel__c = channel;
		interaction.RecordTypeId = IDRT_ACT_INTERACTION;
		interaction.FII_ACT_SEL_Interaction_Category__c = Label.FII_TaskCategory_Interaction; // Indicate if the category is Interactión o communication
		interaction.FII_ACT_SEL_Interaction_Type__c = Label.FII_TaskInteractionType_Input; // Indicate if the interaction is input or output
		return interaction;
	}

	/************************
	 * CONSULTATION METHODS *
	 ************************/

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static List<Case> consultRelatedNeeds(Id recId){
		List<Case> caseNeeds = new List<Case>();
		if(Schema.sObjectType.Case.isAccessible()){
			String queryNeeds = 'SELECT Id, OwnerId, CaseNumber, Subject, FII_CAS_LKP_Campaign__c, CreatedDate, Status, isClosed, RecordType.DeveloperName, FII_TXT_Subtype_Customer_Vision__c, tolabel(Status_Grouper__c), tolabel(FII_SEL_Subtype_Customer_Vision__c), FII_TXT_Claim_Origin__c, FII_TXT_CompanyOwner__c FROM Case WHERE RecordTypeId IN :CAS_NEEDS_RT AND ';
			switch on String.valueOf(recId.getSobjectType()){
				when 'Account' {
					queryNeeds += 'AccountId = :recId ORDER BY CreatedDate desc';
				}
				when 'Lead' {
					queryNeeds += 'Lead__c = :recId ORDER BY CreatedDate desc';
				}
				when 'Contact' {
					queryNeeds += 'ContactId = :recId ORDER BY CreatedDate desc';
				}
				when 'Task' {
					if(Schema.sObjectType.Task.isAccessible()){
						List<String> needsId = new List<String>();
						// First we obtain the related actions
						List<String> actionsCaseId = new List<String>();
						List<Case> antionsCaseList = new List<Case>();
						List<String> actionsTaskId = new List<String>();
						List<Task> actionsTaskList = new List<Task>();
						List<String> actionsQuoteId = new List<String>();
						List<NE__Quote__c> actionsQuoteList = new List<NE__Quote__c>();
						final List<Task> recruitmentInteractions = new List<Task>([SELECT FII_ACT_TXT_Recruitment_interaction__c FROM Task WHERE (FII_ACT_TXT_Main_interaction__c = :recId OR Id = :recId) AND FII_ACT_TXT_Recruitment_interaction__c != null AND RecordTypeId =:IDRT_ACT_INTERACTION]);
						for(Task t :recruitmentInteractions){
							Id recruitmentId = Id.valueOf(t.FII_ACT_TXT_Recruitment_interaction__c);
							switch on String.valueOf(recruitmentId.getSobjectType()){
								when 'Case' {
									actionsCaseId.add(t.FII_ACT_TXT_Recruitment_interaction__c);
								}
								when 'Task' {
									actionsTaskId.add(t.FII_ACT_TXT_Recruitment_interaction__c);
								}
								when 'NE__Quote__c' {
									actionsQuoteId.add(t.FII_ACT_TXT_Recruitment_interaction__c);
								}
							}
						}
						antionsCaseList = [SELECT Id, ParentId FROM Case WHERE Id IN :actionsCaseId];
						actionsTaskList = [SELECT Id, FII_ACT_LKP_WhatId__c, WhatId FROM Task WHERE Id IN :actionsTaskId];
						actionsQuoteList = [SELECT Id, Case__c FROM NE__Quote__c WHERE Id IN : actionsQuoteId];

						// Second we obtain the related needs Id of actions
						for(Case c :antionsCaseList){
							if(c.ParentId == null){
								if(!needsId.contains(c.Id)){
									needsId.add(c.Id);
								}
							} else if(!needsId.contains(c.ParentId)){
								needsId.add(c.ParentId);
							}
						}
						for(Task t : actionsTaskList){
							if(t.WhatId != null){
								if(!needsId.contains(t.WhatId)){
									needsId.add(t.WhatId);
								}
							} else{
								if(!needsId.contains(t.FII_ACT_LKP_WhatId__c)){
									needsId.add(t.FII_ACT_LKP_WhatId__c);
								}
							}
						}
						for(NE__Quote__c q : actionsQuoteList){
							if(!needsId.contains(q.Case__c)){
								needsId.add(q.Case__c);
							}
						}

						// Finaly we obtain the related needs
						queryNeeds += '(Id IN :needsId OR FII_CAS_TXT_Opened_interaction__c = :recId) ORDER BY CreatedDate desc';
					}
				}
			}
			caseNeeds = database.query(queryNeeds);
		}
		return caseNeeds;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static List<SObject> consultRelatedActions(Id recId){
		Map<Id, List<SObject>> relatedActionsMap = consultRelatedActionsBulk(new List<Id>{recId});
		return relatedActionsMap.get(recId);
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	private static Map<Id, List<SObject>> consultRelatedActionsBulk(List<Id> recIdList){
		Map<Id, List<SObject>> relatedActionsMap = new Map<Id, List<SObject>>();
		if(Schema.sObjectType.Task.isAccessible() && Schema.sObjectType.Case.isAccessible()){
			List<Id> recIdsAccount = new List<Id>();
			List<Id> recIdsCase = new List<Id>();
			List<Id> recIdsLead = new List<Id>();
			List<Id> recIdsContact = new List<Id>();
			List<Id> recIdsTask = new List<Id>();
			List<Id> recIdsQuote = new List<Id>();
			List<Id> recIdsOppty = new List<Id> ();

			for(Id recId : recIdList){
				switch on String.valueOf(recId.getSobjectType()){
					when 'Account' {
						recIdsAccount.add(recId);
					}
					when 'Case' {
						recIdsCase.add(recId);
					}
					when 'Lead' {
						recIdsLead.add(recId);
					}
					when 'Contact' {
						recIdsContact.add(recId);
					}
					when 'Task' {
						recIdsTask.add(recId);
					}
					when 'NE__Quote__c' {
						recIdsQuote.add(recId);
					}
					//Se ve desde la RL de la pag de opps
					when 'Opportunity' {
						recIdsOppty.add(recId);
					}
				}
			}

			List<String> needListId = new List<String>();
			List<Case> caseActions = new List<Case>();
			List<Task> taskActions = new List<Task>();
			List<NE__Quote__c> quoteActions = new List<NE__Quote__c>();
			List<Opportunity> opptyActions = new List<Opportunity> ();
			String queryCasesIni = 'SELECT Id, OwnerId, CaseNumber, ParentId, Subject, CreatedDate, Status, isClosed, AccountId, ContactId, Lead__c, Recordtype.DeveloperName, FII_TXT_Subtype_Customer_Vision__c, tolabel(Status_Grouper__c), tolabel(FII_SEL_Subtype_Customer_Vision__c), FII_TXT_Claim_Origin__c, FII_SEL_Class__c, tolabel(FII_SEL_Type_Customer_Vision__c), Estado__c, tolabel(FII_SEL_Result__c), Date_Closed__c, tolabel(FII_SEL_Cause__c), FII_TXT_Description_Agent_Claimer_CNMC__c, FII_TXT_CompanyOwner__c, FII_TXT_Business_Line__c, FII_LKP_Contract__c, FII_FOR_Owner_Platform__c, Parent.CaseNumber, Contact.Name, Owner.Name, Owner_Name__c, LastModifiedBy.Name, LastModifiedById FROM Case WHERE '; // IBAA 841 (JPD) add FII_SEL_Class__c FII_SEL_Type_Customer_Vision__c ... LastModifiedById 
			String queryTasksIni = 'SELECT Id, OwnerId, FII_ACT_AUT_Identifier__c, Subject, CreatedDate, Status, isClosed, FII_ACT_SEL_Interaction_Type__c, FII_ACT_SEL_Interaction_Category__c, FII_ACT_SEL_Channel__c, WhatId, FII_ACT_TXT_Recruitment_interaction__c, FII_ACT_LKP_RelatedClient__c, WhoId, FII_ACT_LKP_WhatId__c, Recordtype.DeveloperName FROM Task WHERE ';
			String queryQuotesIni = 'SELECT Id, NE__Status__c, Case__c, NE__AccountId__c, Related_contact__c, Name, CreatedDate, toLabel(FI_NEQ_SEL_Movement_Type__c) typeLabel FROM NE__Quote__c WHERE ';
			
			String queryCases;
			String queryTasks;
			String queryQuotes;
			String queryOpptys = 'SELECT Id, FI_OPP_LKP_Case__c, FI_OPP_LKP_Lead__c, AccountId, StageName, Name, CreatedDate, NE__TrackingNumber__c  FROM Opportunity WHERE '; //campos componentes lightning
		  
			if(recIdsAccount.size()>0){
				queryCases = queryCasesIni + 'AccountId IN :recIdsAccount AND RecordTypeId IN :CAS_ACTIONS_RT ORDER BY CreatedDate desc';
				queryTasks = queryTasksIni + 'FII_ACT_LKP_RelatedClient__c IN :recIdsAccount AND RecordTypeId IN :ACT_ACTIONS_RT ORDER BY CreatedDate desc';
				queryQuotes = queryQuotesIni + 'NE__AccountId__c IN :recIdsAccount ORDER BY CreatedDate desc';
				queryOpptys = queryOpptys + 'AccountId IN :recIdsAccount ORDER BY CreatedDate DESC';

				caseActions = database.query(queryCases);
				taskActions = database.query(queryTasks);
				quoteActions = database.query(queryQuotes);
				opptyActions = database.query(queryOpptys);
				for(Id recId : recIdsAccount){
					List<SObject> actionsList = new List<SObject>();
					for(Case c : caseActions){
						if(c.AccountId == recId){
							actionsList.add(c);
						}
					}
					for(Task t : taskActions){
						if(t.FII_ACT_LKP_RelatedClient__c == recId){
							actionsList.add(t);
						}
					}
					for(NE__Quote__c q : quoteActions){
						if(q.NE__AccountId__c == recId){
							actionsList.add(q);
						}
					}
					for (Opportunity o : opptyActions){
						if (o.AccountId == recId){
							actionsList.add(o);
						}
					}
					relatedActionsMap.put(recId, actionsList);
				}
			}

			if(recIdsCase.size()>0){
				queryCases = queryCasesIni + 'ParentId IN :recIdsCase AND RecordTypeId IN :CAS_ACTIONS_RT ORDER BY CreatedDate desc';
				queryTasks = queryTasksIni + '((WhatId != null AND WhatId IN :recIdsCase) OR (FII_ACT_LKP_WhatId__c != null AND FII_ACT_LKP_WhatId__c IN :recIdsCase)) AND RecordTypeId IN :ACT_ACTIONS_RT ORDER BY CreatedDate desc';
				queryQuotes = queryQuotesIni + 'Case__c IN :recIdsCase ORDER BY CreatedDate desc';
				queryOpptys = queryOpptys + 'FI_OPP_LKP_Case__c IN :recIdsCase ORDER BY CreatedDate DESC';

				caseActions = database.query(queryCases);
				taskActions = database.query(queryTasks);
				quoteActions = database.query(queryQuotes);
				opptyActions = database.query(queryOpptys);

				for(Id recId : recIdsCase){
					List<SObject> actionsList = new List<SObject>();
					for(Case c : caseActions){
						if(c.ParentId == recId){
							actionsList.add(c);
						}
					}
					for(Task t : taskActions){
						if(t.WhatId == recId || t.FII_ACT_LKP_WhatId__c == recId){
							actionsList.add(t);
						}
					}
					for(NE__Quote__c q : quoteActions){
						if(q.Case__c == recId){
							actionsList.add(q);
						}
					}
					for (Opportunity o : opptyActions){
						if (o.FI_OPP_LKP_Case__c == recId){
							actionsList.add(o);
						}
					}
					relatedActionsMap.put(recId, actionsList);
				}
			}

			if(recIdsLead.size()>0){
				queryCases = queryCasesIni + 'Lead__c IN :recIdsLead AND RecordTypeId IN :CAS_ACTIONS_RT ORDER BY CreatedDate desc';
				queryTasks = queryTasksIni + 'WhoId IN :recIdsLead AND RecordTypeId IN :ACT_ACTIONS_RT ORDER BY CreatedDate desc';              
				queryOpptys = queryOpptys + 'FI_OPP_LKP_Lead__c	 IN :recIdsLead ORDER BY CreatedDate DESC';
				opptyActions = database.query(queryOpptys);
				caseActions = database.query(queryCases);
				taskActions = database.query(queryTasks);
				for(Id recId : recIdsLead){
					List<SObject> actionsList = new List<SObject>();
					for(Case c : caseActions){
						if(c.Lead__c == recId){
							actionsList.add(c);
						}
					}
					for(Task t : taskActions){
						if(t.WhoId == recId){
							actionsList.add(t);
						}
					}
					for (Opportunity o : opptyActions){
						if (o.FI_OPP_LKP_Lead__c == recId){
							actionsList.add(o);
						}
					}
					relatedActionsMap.put(recId, actionsList);
				}
			}

			if(recIdsContact.size()>0){
				queryCases = queryCasesIni + 'ContactId IN :recIdsContact AND RecordTypeId IN :CAS_ACTIONS_RT ORDER BY CreatedDate desc';
				queryTasks = queryTasksIni + 'WhoId IN :recIdsContact AND RecordTypeId IN :ACT_ACTIONS_RT ORDER BY CreatedDate desc';
				queryQuotes = queryQuotesIni + 'Related_contact__c IN :recIdsContact ORDER BY CreatedDate desc';
				//No aplica para Opptys
				caseActions = database.query(queryCases);
				taskActions = database.query(queryTasks);
				quoteActions = database.query(queryQuotes);
				for(Id recId : recIdsContact){
					List<SObject> actionsList = new List<SObject>();
					for(Case c : caseActions){
						if(c.ContactId == recId){
							actionsList.add(c);
						}
					}
					for(Task t : taskActions){
						if(t.WhoId == recId){
							actionsList.add(t);
						}
					}
					for(NE__Quote__c q : quoteActions){
						if(q.Related_contact__c == recId){
							actionsList.add(q);
						}
					}
					relatedActionsMap.put(recId, actionsList);
				}
			}

			if (recIdsOppty.size() > 0){
				queryCases = queryCasesIni + 'Id IN (SELECT FI_OPP_LKP_Case__c FROM Opportunity WHERE Id IN :recIdsOppty) AND RecordTypeId IN :CAS_ACTIONS_RT ORDER BY CreatedDate desc';
				queryTasks = queryTasksIni + 'WhatId IN :recIdsOppty AND RecordTypeId IN :ACT_ACTIONS_RT ORDER BY CreatedDate desc';
				queryQuotes = queryQuotesIni + 'FI_NEQ_LKP_Offering__r.FI_OFF_LKP_Opportunity__c IN :recIdsOppty ORDER BY CreatedDate desc';

				queryOpptys = queryOpptys + 'Id IN :recIdsOppty ORDER BY CreatedDate DESC'; 

				caseActions = database.query(queryCases);
				taskActions = database.query(queryTasks);
				quoteActions = database.query(queryQuotes);
				opptyActions = database.query(queryOpptys);

				for(Id recId : recIdsAccount){
					List<SObject> actionsList = new List<SObject>();
					for(Case c : caseActions){
						for (Opportunity o : opptyActions){
							if (o.FI_OPP_LKP_Case__c == c.Id && o.Id == recId){
								actionsList.add(c);
							}
						}
					}
					for(Task t : taskActions){
						if(t.WhatId == recId){
							actionsList.add(t);
						}
					}
					for(NE__Quote__c q : quoteActions){
						if(q.FI_NEQ_LKP_Offering__r.FI_OFF_LKP_Opportunity__c == recId){
							actionsList.add(q);
						}
					}

					relatedActionsMap.put(recId, actionsList);
				}
			}
			if(recIdsTask.size()>0){
				// Map to store the relationship between action and interaction Id.
				Map<Id, Id> actionRecIdMap = new Map<Id, Id>();
				List<String> actionsCaseId = new List<String>();
				List<String> actionsTaskId = new List<String>();
				List<String> actionsQuoteId = new List<String>();
				List<String> actionsOpptyId = new List<String> ();

				final List<Task> recruitmentInteractions = new List<Task>([SELECT FII_ACT_TXT_Recruitment_interaction__c, FII_ACT_TXT_Main_interaction__c FROM Task WHERE (FII_ACT_TXT_Main_interaction__c IN :recIdsTask OR Id IN :recIdsTask) AND FII_ACT_TXT_Recruitment_interaction__c != null AND RecordTypeId =:IDRT_ACT_INTERACTION]);
				
				for(Task t :recruitmentInteractions){
					Id recruitmentId = Id.valueOf(t.FII_ACT_TXT_Recruitment_interaction__c);
					switch on String.valueOf(recruitmentId.getSobjectType()){
						when 'Case' {
							actionsCaseId.add(t.FII_ACT_TXT_Recruitment_interaction__c);
						}
						when 'Task' {
							actionsTaskId.add(t.FII_ACT_TXT_Recruitment_interaction__c);
						}
						when 'NE__Quote__c' {
							actionsQuoteId.add(t.FII_ACT_TXT_Recruitment_interaction__c);
						}
						when 'Opportunity' {
							actionsOpptyId.add(t.FII_ACT_TXT_Recruitment_interaction__c);
						}
					}
					// Stores the relationship between action and interacction Id.
					if(t.FII_ACT_TXT_Main_interaction__c != null){
						actionRecIdMap.put(t.FII_ACT_TXT_Recruitment_interaction__c, t.FII_ACT_TXT_Main_interaction__c);
					} else{
						actionRecIdMap.put(t.FII_ACT_TXT_Recruitment_interaction__c, t.Id);
					}
				}
				queryCases = queryCasesIni + 'Id IN :actionsCaseId AND RecordTypeId IN :CAS_ACTIONS_RT ORDER BY CreatedDate desc';
				queryTasks = queryTasksIni + 'Id IN :actionsTaskId AND RecordTypeId IN :ACT_ACTIONS_RT ORDER BY CreatedDate desc';
				queryQuotes = queryQuotesIni + 'Id IN :actionsQuoteId AND RecordTypeId IN :ACT_ACTIONS_RT ORDER BY CreatedDate desc';
				queryOpptys = queryOpptys + 'Id IN :actionsOpptyId ORDER BY CreatedDate DESC';

				caseActions = database.query(queryCases);
				taskActions = database.query(queryTasks);
				quoteActions = database.query(queryQuotes);
				opptyActions = database.query(queryOpptys);
				for(Id recId : recIdsTask){
					List<SObject> actionsList = new List<SObject>();
					for(Case c : caseActions){
						if(actionRecIdMap.get(c.Id) == recId){
							actionsList.add(c);
						}
					}
					for(Task t : taskActions){
						if(actionRecIdMap.get(t.Id) == recId){
							actionsList.add(t);
						}
					}
					for(NE__Quote__c q : quoteActions){
						if(actionRecIdMap.get(q.Id) == recId){
							actionsList.add(q);
						}
					}
					for (Opportunity o : opptyActions){
						if (actionRecIdMap.get(o.Id) == recId){
							actionsList.add(o);
						}
					}
					relatedActionsMap.put(recId, actionsList);
				}
			}
		}
		return relatedActionsMap;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static List<Task> consultRelatedInteractions(Id recId){
		List<Task> interactions = new List<Task>();
		if(Schema.sObjectType.Task.isAccessible()){
			String queryInteractions = 'SELECT Id, FII_ACT_AUT_Identifier__c, OwnerId, CallObject, TV_ACT_LKP_CallClassification__c, TV_ACT_LKP_CallClassification__r.TV_CCL_FLG_IsSellOk__c, TV_Telefono_Marcado__c, FII_ACT_FOR_Interaction_Duration__c,FII_ACT_FOR_Interaction_EndTime__c, FII_ACT_FOR_Interaction_Duration_Order__c, FII_ACT_TXT_Recruitment_interaction__c, FII_ACT_TXT_RecIt_Name__c, FII_ACT_SEL_Interaction_Type__c, FII_ACT_SEL_Interaction_Category__c, FII_ACT_SEL_Channel__c, What.Name,  WhatId, Who.Id, Who.Name, Status, CreatedDate, Subject, FII_ACT_TXT_Main_interaction__c, FII_ACT_LKP_WhatId__r.Id, FII_ACT_LKP_WhatId__r.CaseNumber FROM Task WHERE RecordTypeId = :IDRT_ACT_INTERACTION AND FII_ACT_TXT_Main_interaction__c = null AND ';
			switch on String.valueOf(recId.getSobjectType()){
				when 'Account' {
					queryInteractions += 'FII_ACT_LKP_RelatedClient__c = :recId ORDER BY CreatedDate desc';
				}
				when 'Case' {
					// Consult main interactions of child interactions
					List<String> mainInteractionsId = new List<String>();
					Map<Id, SObject> recruitmentInteractions = new Map<Id, SObject>(consultRelatedActions(recId));
					List<Id> recruitmentInteractionsId = new List<Id>();
					for(SObject obj :recruitmentInteractions.values()){
						if(!recruitmentInteractionsId.contains(obj.Id)){
							recruitmentInteractionsId.add(obj.Id);
						}
					}
					List<AggregateResult> mainInteractions = new List<AggregateResult>([SELECT FII_ACT_TXT_Main_interaction__c FROM Task WHERE (FII_ACT_TXT_Recruitment_interaction__c IN :recruitmentInteractionsId OR WhatId = :recId OR FII_ACT_LKP_WhatId__c = :recId) AND FII_ACT_TXT_Main_interaction__c != null GROUP BY FII_ACT_TXT_Main_interaction__c]);
					for(AggregateResult ar :mainInteractions){
						mainInteractionsId.add((String)ar.get('FII_ACT_TXT_Main_interaction__c'));
					}
					queryInteractions += '(Id IN :mainInteractionsId OR WhatId = :recId OR FII_ACT_LKP_WhatId__c = :recId OR (FII_ACT_TXT_Recruitment_interaction__c IN :recruitmentInteractionsId AND FII_ACT_TXT_Main_interaction__c = null)) ORDER BY CreatedDate desc';
				}
				when 'Lead', 'Contact' {
					queryInteractions += 'WhoId = :recId ORDER BY CreatedDate desc';
				}
			}
			system.debug('@MPN query: ' + queryInteractions);
			interactions = database.query(queryInteractions);
		}
		return interactions;
	}

	/**
	 * Returns a
	 * 
	 * @param
	 * @return
	 */
	public static Task getInteractionInProgress(Id recId){
		final Map<Id, List<Task>> interactionInProgressMap = getInteractionsInProgressBulk(new List<Id>{recId}, false);
		if(!interactionInProgressMap.isEmpty()){
			for(Task t :interactionInProgressMap.get(recId)){
				if(t.FII_ACT_TXT_Main_interaction__c == null){
					return t;
				}
			}
		}
		return null;
	}

	/**
	 * Returns a
	 * 
	 * @param
	 * @return
	 */
	public static Map<Id, List<Task>> getInteractionsInProgressBulk(List<Id> recIdList, Boolean getChilds){
		Map<Id, List<Task>> interactionInProgressMap = new Map<Id, List<Task>>();
		if(Schema.sObjectType.Task.isAccessible()){
			List<Id> recIdsAccount = new List<Id>();
			List<Id> recIdsCase = new List<Id>();
			List<Id> recIdsLeadAndContact = new List<Id>();
			List<Id> recIdsAddress= new List<Id>();
			List<Id> recIdConfigItem = new List<Id>();
			List<Id> recIdQuotes = new List<Id>();
			List<Id> recIdOpptys = new List<Id>();
			for(Id recId : recIdList){
				if (recId == null) {
					continue;
				}
				switch on String.valueOf(recId.getSobjectType()){
					when 'Account' {
						recIdsAccount.add(recId);
					}
					when 'Case' {
						recIdsCase.add(recId);
					}
					when 'Lead', 'Contact' {
						recIdsLeadAndContact.add(recId);
					}
					when 'B2C_Address__c' {//Paton
						recIdsAddress.add(recId);
					}
					when 'NE__OrderItem__c'{
						recIdConfigItem.add(recId);
					}
					when 'NE__Quote__c'{
						recIdQuotes.add(recId);
					}
					when 'Opportunity'{
						recIdOpptys.add(recId);
					}
				}
			}
			List<Task> interactionList;
			final String userId = UserInfo.getUserId();
            String queryInteractionIni = 'SELECT Id, FII_ACT_SEL_SubTipoTarea__c, FII_ACT_TXT_CampaignMemberId__c, CallObject, TV_ACT_TXT_MarcadorCampaignId__c, FII_ACT_LKP_Campaign__c, FII_ACT_TXT_Service__c, Tipo__c, SubTipo__c, FII_ACT_TXT_NLInfo__c, FII_ACT_AUT_Identifier__c, FII_ACT_LKP_RelatedClient__c, FII_ACT_LKP_RelatedClient__r.Name, OwnerId, FII_ACT_FOR_Interaction_Duration__c, FII_ACT_FOR_Interaction_EndTime__c, FII_ACT_FOR_Interaction_Duration_Order__c, FII_ACT_TXT_Recruitment_interaction__c, FII_ACT_TXT_RecIt_Name__c, FII_ACT_SEL_Interaction_Type__c, FII_ACT_SEL_Interaction_Category__c, FII_ACT_SEL_Channel__c, What.Name,  WhatId, WhoId, Who.Name, Status, CreatedDate, Subject, FII_ACT_TXT_Main_interaction__c, FII_ACT_LKP_WhatId__r.Id, FII_ACT_LKP_WhatId__r.CaseNumber, FII_ACT_TXT_Role__c, FII_ACT_FOR_WhatId__c, Owner.Name, AccountId, Account.Name, FII_ACT_TXT_CaseNeedNumber__c FROM Task WHERE RecordTypeId = :IDRT_ACT_INTERACTION AND IsClosed = false AND OwnerId = :userId AND ';
			if(!getChilds){
				queryInteractionIni +=  'FII_ACT_TXT_Main_interaction__c = null AND ';
			}
			String queryInteraction;
			if(recIdsAccount.size()>0){
				queryInteraction = queryInteractionIni + 'FII_ACT_LKP_RelatedClient__c IN :recIdsAccount ORDER BY CreatedDate desc';
				interactionList = database.query(queryInteraction);

				for(Id recId : recIdsAccount){
					List<Task> interactionAndChildsList = new List<Task>();
					for(Task t : interactionList){
						if(t.FII_ACT_LKP_RelatedClient__c == recId){
							interactionAndChildsList.add(t);
						}
					}
					interactionInProgressMap.put(recId, interactionAndChildsList);
				}
			}

			if(recIdsCase.size()>0){
				if(Schema.sObjectType.Task.isAccessible()){
					// Map to store the relationship between need and (client or lead) Id.
					Map<Id, Id> needRelatedMap = new Map<Id, Id>();
					Id relatedId;
					final List<Case> needsList = [SELECT Id, AccountId, Lead__c FROM Case WHERE Id IN :recIdsCase];
					List<String> accIdList = new List<String>();
					List<String> leadIdList = new List<String>();
					for(Case need : needsList){
						if(need.AccountId != null){
							accIdList.add(need.AccountId);
							needRelatedMap.put(need.Id, need.AccountId);
						} else{
							leadIdList.add(need.Lead__c);
							needRelatedMap.put(need.Id, need.Lead__c);
						}
					}
					queryInteraction = queryInteractionIni + '((FII_ACT_LKP_RelatedClient__c IN :accIdList) OR (WhoId IN :leadIdList)) ORDER BY CreatedDate desc';
					interactionList = database.query(queryInteraction);
					for(Id recId : recIdsCase){
						List<Task> interactionAndChildsList = new List<Task>();
						relatedId = needRelatedMap.get(recId);
						for(Task t : interactionList){
							if(t.FII_ACT_LKP_RelatedClient__c == relatedId || t.WhoId == relatedId){
								interactionAndChildsList.add(t);
							}
						}
						interactionInProgressMap.put(recId, interactionAndChildsList);
					}
				}
			}

			if(recIdsLeadAndContact.size()>0){
				queryInteraction = queryInteractionIni + 'WhoId IN :recIdsLeadAndContact ORDER BY CreatedDate desc';
				interactionList = database.query(queryInteraction);
				for(Id recId : recIdsLeadAndContact){
					List<Task> interactionAndChildsList = new List<Task>();
					for(Task t : interactionList){
						if(t.WhoId == recId){
							interactionAndChildsList.add(t);
						}
					}
					interactionInProgressMap.put(recId, interactionAndChildsList);
				}
			}
			
			if(recIdConfigItem.size()>0){
				if(Schema.sObjectType.NE__OrderItem__c.isAccessible()){
					final List<NE__OrderItem__c> confItList = new List<NE__OrderItem__c>([SELECT Id, NE__Account__c FROM NE__OrderItem__c WHERE Id IN :recIdConfigItem]);
					List<Id> ciIdsList = new List<Id>();
					for(NE__OrderItem__c ci :confItList){
						ciIdsList.add(ci.NE__Account__c);
					}
					queryInteraction = queryInteractionIni + 'FII_ACT_LKP_RelatedClient__c IN :ciIdsList ORDER BY CreatedDate desc';
					interactionList = database.query(queryInteraction);
					for(NE__OrderItem__c ci : confItList){
						List<Task> interactionAndChildsList = new List<Task>();
						for(Task t : interactionList){
							if(t.FII_ACT_LKP_RelatedClient__c == ci.NE__Account__c){
								interactionAndChildsList.add(t);
							}
						}
						interactionInProgressMap.put(ci.Id, interactionAndChildsList);
					}
				}
			}
			
			if(recIdQuotes.size()>0){
				if(Schema.sObjectType.NE__Quote__c.isAccessible()){
					final List<NE__Quote__c> quoteList = new List<NE__Quote__c>([SELECT Id, NE__AccountId__c FROM NE__Quote__c WHERE Id IN :recIdQuotes]);
					List<Id> quoteIdsList = new List<Id>();
					for(NE__Quote__c quote :quoteList){
						quoteIdsList.add(quote.NE__AccountId__c);
					}
					queryInteraction = queryInteractionIni + 'FII_ACT_LKP_RelatedClient__c IN :quoteIdsList ORDER BY CreatedDate desc';
					interactionList = database.query(queryInteraction);
					for(NE__Quote__c quote : quoteList){
						List<Task> interactionAndChildsList = new List<Task>();
						for(Task t : interactionList){
							if(t.FII_ACT_LKP_RelatedClient__c == quote.NE__AccountId__c){
								interactionAndChildsList.add(t);
							}
						}
						interactionInProgressMap.put(quote.Id, interactionAndChildsList);
					}
				}
			}

			if (recIdOpptys.size()>0){
				Map<Id, Id> opptyRelatedMap = new Map<Id, Id>();
				Id relatedId;
				final List<Opportunity> opportunityList = [SELECT Id, AccountId, FI_OPP_LKP_Lead__c FROM Opportunity WHERE Id IN :recIdOpptys];
				List<String> accIdList = new List<String>();
				List<String> leadIdList = new List<String>();
				for(Opportunity oppty : opportunityList){
					if(oppty.AccountId != null){
						accIdList.add(oppty.AccountId);
						opptyRelatedMap.put(oppty.Id, oppty.AccountId);
					} else{
						leadIdList.add(oppty.FI_OPP_LKP_Lead__c);
						opptyRelatedMap.put(oppty.Id, oppty.FI_OPP_LKP_Lead__c);
					}
				}
				
				queryInteraction = queryInteractionIni + '((FII_ACT_LKP_RelatedClient__c IN :accIdList) OR (WhoId IN :leadIdList)) ORDER BY CreatedDate desc';
				interactionList = database.query(queryInteraction);
				
				
				for(Id recId : recIdsCase){
					List<Task> interactionAndChildsList = new List<Task>();
					relatedId = opptyRelatedMap.get(recId);
					for(Task t : interactionList){
						if(t.FII_ACT_LKP_RelatedClient__c == relatedId || t.WhoId == relatedId){
							interactionAndChildsList.add(t);
						}
					}
					interactionInProgressMap.put(recId, interactionAndChildsList);
				}
			} 
			
			if(recIdsAddress.size()>0){
				if(Schema.sObjectType.B2C_Address__c.isAccessible()){
					final List<B2C_Address__c> addresList = new List<B2C_Address__c>([SELECT Id, Account__c FROM B2C_Address__c WHERE Id IN :recIdsAddress]);
					List<Id> accIdsList = new List<Id>();
					for(B2C_Address__c adr :addresList){
						accIdsList.add(adr.Account__c);
					}
					queryInteraction = queryInteractionIni + 'FII_ACT_LKP_RelatedClient__c IN :accIdsList ORDER BY CreatedDate desc';
					interactionList = database.query(queryInteraction);
					for(B2C_Address__c addres : addresList){
						List<Task> interactionAndChildsList = new List<Task>();
						for(Task t : interactionList){
							if(t.FII_ACT_LKP_RelatedClient__c == addres.Account__c){
								interactionAndChildsList.add(t);
							}
						}
						interactionInProgressMap.put(addres.Id, interactionAndChildsList);
					}
				}
			}
		}
		return interactionInProgressMap;
	}

	/**
	 * Returns a
	 * 
	 * @param
	 * @return
	 */
	public static SObject consultRecordPrimary(Id recId){
		sObject obj;
		switch on String.valueOf(recId.getSobjectType()){
			when 'Account' {
				if(Schema.sObjectType.Account.isAccessible()){
					obj = [SELECT Id, Name FROM Account WHERE Id =: recId LIMIT 1];
				}
			}
			when 'Contact' {
				if(Schema.sObjectType.Contact.isAccessible()){
					obj = [SELECT Id, Name, AccountId FROM Contact WHERE Id =: recId LIMIT 1];
				}
			}
			when 'Case' {
				if(Schema.sObjectType.Case.isAccessible()){
					obj = [SELECT  Id, AccountId, ContactId, Lead__c, FII_CAS_LKP_Campaign__c, Origin, CaseNumber FROM Case WHERE Id =: recId LIMIT 1];
				}
			}
			when 'Lead' {
				if(Schema.sObjectType.Lead.isAccessible()){
					obj = [SELECT Id, Name FROM Lead WHERE Id =: recId LIMIT 1];
				}
			}
			when 'Task' {
				if(Schema.sObjectType.Task.isAccessible()){
					obj = [SELECT Id, FII_ACT_AUT_Identifier__c, FII_ACT_LKP_RelatedClient__c, WhoId FROM Task WHERE Id =: recId LIMIT 1];
				}
			}
		}
		return obj;
	}

	public static Boolean isTheEventForMe(Id myRecId, Id eventRecId, Task interactionInProgress){
		Boolean isTheEventForMe = false;
		Id recordToCompare = eventRecId;

		switch on String.valueOf(eventRecId.getSobjectType()){
			when 'Contact' {
				if(interactionInProgress != null){
					recordToCompare = interactionInProgress.FII_ACT_LKP_RelatedClient__c;
				} else{
					Contact con = (Contact)consultRecordPrimary(eventRecId);
					recordToCompare = con.AccountId;
				}
			}
			when 'Case' {
				final Case c = (Case)consultRecordPrimary(eventRecId);
				if(c.AccountId != null){
					recordToCompare = c.AccountId;
				} else{
					recordToCompare = c.Lead__c;
				}
			}
			when 'Task' {
				final Task t = (Task)consultRecordPrimary(eventRecId);
				if(t.FII_ACT_LKP_RelatedClient__c != null){
					recordToCompare = t.FII_ACT_LKP_RelatedClient__c;
				} else{
					recordToCompare = t.WhoId;
				}
			}
			when 'NE__Quote__c' {

			}
			when 'NE__OrderItem__c'{

			}
		}

		switch on String.valueOf(myRecId.getSobjectType()){
			when 'Account', 'Lead' {
				if(myRecId == recordToCompare){
					isTheEventForMe = true;
				}
			}
			when 'Contact' {
				if(Schema.sObjectType.AccountContactRelation.isAccessible()){
					if(interactionInProgress != null && interactionInProgress.WhoId == myRecId){
						isTheEventForMe = true;
					}
				}
			}
			when 'Case' {
				final Case c = (Case)consultRecordPrimary(myRecId);
				if(c.AccountId == recordToCompare || c.Lead__c == recordToCompare){
					isTheEventForMe = true;
				}
			}
			when 'Task' {
				final Task t = (Task)consultRecordPrimary(myRecId);
				if(recordToCompare == t.FII_ACT_LKP_RelatedClient__c || recordToCompare == t.WhoId){
					isTheEventForMe = true;
				}
			}
			when 'NE__Quote__c' {

			}
			when 'NE__OrderItem__c'{
				
			}
		}

		return isTheEventForMe;
	}

	public static Boolean disableButton(Id myRecId, Id eventRecId, Task itInCourse){
		Boolean disabled = null;
		if(myRecId == eventRecId){ // The event is for me
			if(itInCourse == null){
				disabled = false;
			} else{
				if((itInCourse.FII_ACT_LKP_RelatedClient__c == myRecId || itInCourse.WhoId == myRecId) && itInCourse.WhoId != null){
					disabled = false;
				} else{
					disabled = true;
				}
			}
		}
		return disabled;
	}

	/************************
	 * TRIGGER CASE METHODS *
	 ************************/

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static Set<Id> getNeedOrActionCasesId(List<sObject> newRecordsList){
		// Set of identifiers of new cases
		Set<Id> casesId = new Set<Id>();
		for(Case c: (List<Case>)newRecordsList){
			if((CAS_ACTIONS_RT.contains(String.valueOf(c.RecordTypeId)) && c.ParentId != null) || c.RecordTypeId == IDRT_CAS_NEED){
				casesId.add(c.Id);
			}
		}
		return casesId;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static Set<Id> getParentCasesId(List<sObject> newRecordsList){
		// Set of identifiers of related parent cases
		Set<Id> parentCasesId = new Set<Id>();
		for(Case c: (List<Case>)newRecordsList){
			parentCasesId.add(c.ParentId);
		}
		return parentCasesId;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static Map<Id, Case> getAllCases(Set<Id> casesId, Set<Id> parentCasesId){
		Map<Id, Case> allCasesMap = new Map<Id, Case>();
		if(Schema.sObjectType.Case.isAccessible()){
			Set<Id> allCasesId = new Set<Id>();
			allCasesId.addAll(casesId);
			allCasesId.addAll(parentCasesId);
			// Map of new cases and related parent cases.
			allCasesMap = new Map<Id, Case>(
				[SELECT Id,
						Case_AccountName__c, 
						ParentId, 
						FII_CAS_TXT_Opened_interaction__c, 
						FII_CAS_TXT_LastChannelInteracts__c, 
						RecordTypeId, 
						AccountId, 
						Origin, 
						OwnerId,
						ContactId, 
						Subject, 
						Status,
						FII_CAS_DAT_Resolution_Date__c, 
						Type,
						CaseNumber,
						FII_CAS_FLG_RelatedWithInteraction__c,
						FII_CAS_NUM_RelatedInteractions__c,
						Lead__c,
						FII_CAS_FOR_Channel__c,
						FII_CAS_LKP_Campaign__c,
						FII_CAS_FLG_EditedOnLayout__c
						FROM Case WHERE Id IN :allCasesId]);
		}
		return allCasesMap;
	}

	/**
	 * Returns a
	 * @param
	 * @param
	 * @return
	 */
	public static List<List<Case>> getSplitedCases(List<Case> allCasesList, Set<Id> parentCasesId){
		List<List<Case>> splitedCases = new List<List<Case>>();
		List<Case> parentCaseList = new List<Case>();
		List<Case> needCaseList = new List<Case>();
		List<Case> actionCaseList = new List<Case>();
		// We separate all cases in parent cases, new needs and new actions
		for(Case c: allCasesList){
			if(parentCasesId.contains(c.Id)){
				parentCaseList.add(c);
			} else{
				if(c.RecordTypeId == IDRT_CAS_NEED){
					needCaseList.add(c);
				} else if(CAS_ACTIONS_RT.contains(String.valueOf(c.RecordTypeId))) {
					actionCaseList.add(c);
				}
			}
		}
		splitedCases.add(parentCaseList);
		splitedCases.add(needCaseList);
		splitedCases.add(actionCaseList);
		return splitedCases;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static List<List<SObject>> casesWithOpenedInteraction(List<Case> casesList, Map<Id, List<Task>> interactionsInProgressMap, Map<Id, Case> allCasesMap){
		List<List<SObject>> casesAndTask = new List<List<SObject>>();
		List<Case> casesToUpdate = new List<Case>();
		List<Case> casesWithChildInteractionToCreate = new List<Case>();
		// Lista de interacciones a las que hay que actualizarle la necesidad o la actuaicón relacionada
		List<Task> itToUpdateWhatIdOrRecItId = new List<Task>();
		for(Case c: casesList){
			List<Task> interactionAndChilds = interactionsInProgressMap.get(getRelatedClientsOrLeads(new List<SObject>{c})[0]);
			Task t = null;
			if(interactionAndChilds != null){
				for(Task interaction :interactionAndChilds){
					if(interaction.FII_ACT_TXT_Main_interaction__c == null){
						t = interaction;
						break;
					}
				}
			}
			if(t != null){
				if(c.Origin == null){ // si el canal ya viene informado en la creación, lo dejamos como estaba (incidencia CCDD - canal Chat app)
                    c.Origin = t.FII_ACT_SEL_Channel__c;
                }               
				if(t.FII_ACT_LKP_RelatedClient__c != null){
					c.ContactId = t.WhoId;
				} else{
					c.Lead__c = t.WhoId;
				}
				if(c.parentId != null && allCasesMap.get(c.parentId) != null){ // It's new action
					Case cParent = allCasesMap.get(c.parentId);
					if(cParent.FII_CAS_TXT_Opened_interaction__c == null){
						if(cParent.FII_CAS_NUM_RelatedInteractions__c != null){
							cParent.FII_CAS_NUM_RelatedInteractions__c = cParent.FII_CAS_NUM_RelatedInteractions__c + 1;
							cParent.FII_CAS_TXT_ModelSurvey__c = '';
							cParent.FII_CAS_TXT_MediumPresentationCN__c = '';
							cParent.FII_FLG_SurveyAlreadySent__c = false;
						} else{
							cParent.FII_CAS_NUM_RelatedInteractions__c = 1;
						}
						cParent.FII_CAS_TXT_Opened_interaction__c = t.Id;
						cParent.FII_CAS_TXT_Last_interaction__c = t.Id;
					}
					cParent.FII_CAS_TXT_LastChannelInteracts__c = t.FII_ACT_SEL_Channel__c;
					casesToUpdate.add(cParent);
				} else{ // It's a new need
					c.FII_CAS_TXT_Opened_interaction__c = t.Id;
					c.FII_CAS_TXT_Last_interaction__c = t.Id;
					c.FII_CAS_NUM_RelatedInteractions__c = 1;
					c.FII_CAS_TXT_LastChannelInteracts__c = t.FII_ACT_SEL_Channel__c;
				}

				// If it is an interaction that is not yet related with need or action
				if(t.WhatId == null && t.FII_ACT_LKP_WhatId__c == null && t.FII_ACT_TXT_Recruitment_interaction__c == null){
					if(c.parentId == null){ // It's new need
						if(c.Lead__c != null){ // It's a lead
							t.FII_ACT_LKP_WhatId__c = c.Id;
						} else{
							t.WhatId = c.Id;
						}
						t.FII_ACT_TXT_CaseNeed__c = c.Id;
						t.FII_ACT_TXT_CaseNeedType__c = c.Type;
						t.FII_ACT_TXT_CaseNeedNumber__c = c.CaseNumber;
						// For the Power of One, only the first interaction related with the case need is filled with 1
						if(!c.FII_CAS_FLG_RelatedWithInteraction__c){
							t.FII_ACT_NUM_POCaseNeed__c = 1;
							c.FII_CAS_FLG_RelatedWithInteraction__c = true;
						}
						itToUpdateWhatIdOrRecItId.add(t);
					} else{ // It's new action
						t.FII_ACT_TXT_Recruitment_interaction__c = c.Id;
						t.FII_ACT_TXT_RecIt_Name__c = c.CaseNumber;
						itToUpdateWhatIdOrRecItId.add(t);
					}
				} else if(t.FII_ACT_TXT_Recruitment_interaction__c == null && c.parentId != null){ 
					t.FII_ACT_TXT_Recruitment_interaction__c = c.Id;
					t.FII_ACT_TXT_RecIt_Name__c = c.CaseNumber;
					itToUpdateWhatIdOrRecItId.add(t);
				} else{ 
					Boolean createInteraction = true;
					// Comprobamos si existe una interacción hija relacionada con esta necesidad a la que podamos relacionar la actuación
					for(Task interaction :interactionAndChilds){
						if((interaction.WhatId == c.parentId || interaction.FII_ACT_LKP_WhatId__c == c.parentId) 
								&& interaction.FII_ACT_TXT_Main_interaction__c != null 
								&& interaction.FII_ACT_TXT_Recruitment_interaction__c == null){
							interaction.FII_ACT_TXT_Recruitment_interaction__c = c.Id;
							interaction.FII_ACT_TXT_RecIt_Name__c = c.CaseNumber;
							itToUpdateWhatIdOrRecItId.add(interaction);
							createInteraction = false;
							break;
						}
					}
					if(createInteraction){ // Create child interaction
						casesWithChildInteractionToCreate.add(c);
					}
				}
				casesToUpdate.add(c);
			}
		}
		casesAndTask.add(casesToUpdate);
		casesAndTask.add(casesWithChildInteractionToCreate);
		casesAndTask.add(itToUpdateWhatIdOrRecItId);
		return casesAndTask;
	}

// START - everis (LHZ) - 2019/06/27 IBBA's 411 - 858 - 861 - 366
	public static void sendSurveyCase(Map<Id, Case> newCases, Map<Id, Case> oldCases) {

		Map<String,Case> mapCaseToSendSurvey = new Map<String,Case>();
		Map<String,List<sObject>> mapCaseToSendSurvey3 = new Map<String,List<sObject>>();
		List<Task> interactionClosed = new List<Task>();
		//List<Case> casesOk = new List<Case>();
		List<Id> LastInt = new List<Id>();
		//final Encuestas_Calidad_Percibida__c ecp = Encuestas_Calidad_Percibida__c.getOrgDefaults(); 
		for(Case oldCase : oldCases.values()){ //itero valores viejos
			for(Case newCase : newCases.values()){ //itero valores nuevos
				if( oldCase.Id == newCase.Id //Si son la misma necesidad
					&& newCase.recordTypeId == IDRT_CAS_NEED //Si es de tipo Necesidad
					&& newCase.Status != oldCase.Status    //Si el estado cambia
					&& !newCase.FII_FLG_SurveyAlreadySent__c //Si no se a enviado aún una encuesta
					&& newCase.Status == Label.FII_CaseStatus_Resolved){  //Si el estado cambia a estado Resolved
					mapCaseToSendSurvey.put(newCase.Id, newCase ); //Añado a la lista para enviar la encuesta
					LastInt.add(newCase.FII_CAS_TXT_Last_interaction__c);//Añado a la lista la última interacción
				}
			}
		}

		if(!mapCaseToSendSurvey.isEmpty()){ //Si tengo Necesidades en estado cerrado con interacciones

			interactionClosed = [ SELECT Id FROM Task 
								WHERE RecordTypeId = :IDRT_ACT_INTERACTION
								AND FII_ACT_SEL_Interaction_Type__c = :Label.FII_TaskInteractionType_Input
								AND Status = :Label.FII_TaskStatus_Completed
								//AND FII_ACT_TXT_Main_interaction__c = null
								AND Id IN :LastInt];
			
		}                   
				 
		if( !interactionClosed.isEmpty() ) { //Si no existen interacciones principales cerradas
			for(Task t : interactionClosed) {//Itero las interacciones cerradas
				for(Case c : mapCaseToSendSurvey.values()){//Itero las necesidades 
					if(t.Id == c.FII_CAS_TXT_Last_interaction__c){ 
						if(mapCaseToSendSurvey3.isEmpty() ){
							mapCaseToSendSurvey3.put('3', new List<Case>{c});
						}else{
							mapCaseToSendSurvey3.get('3').add(c);
						}
					}
				}
			}
		}
		
		//casesOk = checkParametricsCases(mapCaseToSendSurvey3); //Comprobamos que los casos cumplen con las paramétricas
		Map<String,List<sObject>> objectsToUpdate = checkParametrics(mapCaseToSendSurvey3);
		/*casesOk = (List<Case>) objectsToUpdate.get('Case');
		update casesOK;
		*/
	}
	// END - everis (LHZ) - 2019/06/27 IBBA's 411 - 858 - 861 - 366

	/************************
	 * TRIGGER TASK METHODS *
	 ************************/

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static Set<Id> getActionTaskId(List<SObject> newRecordsList){
		// Set of new actions
		Set<Id> actionIds = new Set<Id>();
		for(Task t: (List<Task>)newRecordsList){
			if(ACT_ACTIONS_RT.contains(String.valueOf(t.RecordTypeId))){
				actionIds.add(t.Id);
			}
		}
		return actionIds;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static List<Task> getActionTaskList(Set<Id> actionTaskId){
		// List of new actions
		List<Task> actionList = new List<Task>();
		if(Schema.sObjectType.Task.isAccessible()){
			actionList = [SELECT Id,
							FII_ACT_LKP_RelatedClient__c,
							WhoId,
							WhatId,
							FII_ACT_SEL_Channel__c,
							FII_ACT_LKP_WhatId__c,
							FII_ACT_AUT_Identifier__c,
							Status,
							Subject
							FROM Task WHERE Id IN :actionTaskId];
		}
		return actionList;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static Map<Id, Case> getRelatedNeeds(List<Task> actionTaskList){
		Map<Id, Case> relatedNeedsMap = new Map<Id, Case>();
		if(Schema.sObjectType.Case.isAccessible()){
			// Set of identifiers of needs
			Set<Id> needsId = new Set<Id>();
			for(Task t: actionTaskList){
				if(t.FII_ACT_LKP_WhatId__c != null){
					needsId.add(t.FII_ACT_LKP_WhatId__c);
				} else{
					needsId.add(t.WhatId);
				}
			}
			// Map of needs
			relatedNeedsMap = new Map<Id, Case>([SELECT Id,
										Case_AccountName__c, 
										FII_CAS_TXT_Opened_interaction__c, 
										AccountId, 
										Origin, 
										OwnerId,
										ContactId, 
										Subject, 
										Status,
										FII_CAS_DAT_Resolution_Date__c,
										Type,
										CaseNumber,
										FII_CAS_FLG_RelatedWithInteraction__c,
										FII_CAS_NUM_RelatedInteractions__c,
										FII_CAS_TXT_LastChannelInteracts__c,
										Lead__c,
										FII_CAS_FLG_EditedOnLayout__c
										FROM Case WHERE Id IN :needsId]);
		}
		return relatedNeedsMap;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @param
	 * @return
	 */
	public static List<List<SObject>> actionsWithOpenedInteraction(List<Task> actionTaskList, Map<Id, List<Task>> interactionsInProgressMap, Map<Id, Case> relatedNeedsMap){
		List<List<SObject>> caseAndTasks = new List<List<SObject>>();
		List<Case> needCasesToUpdate = new List<Case>();
		List<Task> actionsWithInteractionToCreate = new List<Task>();
		List<Task> interactionsToUpdateRecId = new List<Task>();
		List<Task> actToUpdateIntInfo = new List<Task>();
		for(Task action: actionTaskList){
			final List<Task> interactionAndChilds = interactionsInProgressMap.get(getRelatedClientsOrLeads(new List<SObject>{action})[0]);
			Task t = null;
			if(interactionAndChilds != null){
				for(Task interaction :interactionAndChilds){
					if(interaction.FII_ACT_TXT_Main_interaction__c == null){
						t = interaction;
						break;
					}
				}
			}
			if(t != null){
				action.FII_ACT_SEL_Channel__c = t.FII_ACT_SEL_Channel__c;
				action.WhoId = t.WhoId;
				actToUpdateIntInfo.add(action);
				Case need = new Case();
				if(action.FII_ACT_LKP_WhatId__c != null){
					need = relatedNeedsMap.get(action.FII_ACT_LKP_WhatId__c);
				} else{
					need = relatedNeedsMap.get(action.WhatId);
				}
				if(need.FII_CAS_TXT_Opened_interaction__c == null){
					if(need.FII_CAS_NUM_RelatedInteractions__c != null){
						need.FII_CAS_NUM_RelatedInteractions__c = need.FII_CAS_NUM_RelatedInteractions__c + 1;
						need.FII_CAS_TXT_ModelSurvey__c = '';
						need.FII_CAS_TXT_MediumPresentationCN__c = '';
						need.FII_FLG_SurveyAlreadySent__c = false;
					} else{
						need.FII_CAS_NUM_RelatedInteractions__c = 1;
					}
					need.FII_CAS_TXT_Opened_interaction__c = t.Id;
					need.FII_CAS_TXT_Last_interaction__c = t.Id;
				}
				need.FII_CAS_TXT_LastChannelInteracts__c = action.FII_ACT_SEL_Channel__c;
				
				
				// If it is an interaction that is not yet related with an action
				if(t.FII_ACT_TXT_Recruitment_interaction__c == null){
					t.FII_ACT_TXT_Recruitment_interaction__c = action.Id;
					t.FII_ACT_TXT_RecIt_Name__c = action.FII_ACT_AUT_Identifier__c;
					if(!need.FII_CAS_FLG_RelatedWithInteraction__c){
						t.FII_ACT_NUM_POCaseNeed__c = 1;
						need.FII_CAS_FLG_RelatedWithInteraction__c= true;
					}
					interactionsToUpdateRecId.add(t);
				} else{
					Boolean createInteraction = true;
					// Comprobamos si existe una interacción hija relacionada con esta necesidad a la que podamos relacionar la actuación
					for(Task interaction :interactionAndChilds){
						if((interaction.WhatId == need.Id || interaction.FII_ACT_LKP_WhatId__c == need.Id) 
								&& interaction.FII_ACT_TXT_Main_interaction__c != null 
								&& interaction.FII_ACT_TXT_Recruitment_interaction__c == null){
							interaction.FII_ACT_TXT_Recruitment_interaction__c = action.Id;
							interaction.FII_ACT_TXT_RecIt_Name__c = action.FII_ACT_AUT_Identifier__c;
							if(!need.FII_CAS_FLG_RelatedWithInteraction__c){
								interaction.FII_ACT_NUM_POCaseNeed__c = 1;
								need.FII_CAS_FLG_RelatedWithInteraction__c= true;
							}
							interactionsToUpdateRecId.add(interaction);
							createInteraction = false;
							break;
						}
					}
					if(createInteraction){
						actionsWithInteractionToCreate.add(action);
					}
				}
				needCasesToUpdate.add(need);
			}
		}
		caseAndTasks.add(needCasesToUpdate);
		caseAndTasks.add(actionsWithInteractionToCreate);
		caseAndTasks.add(interactionsToUpdateRecId);
		caseAndTasks.add(actToUpdateIntInfo);
		return caseAndTasks;
	}

	/**
	 * Method to complete a task if the e-mail or SMS required by the contact has been sent
	 *
	 * @param map of task with old values
	 * @param list of task with new values
	 * @return list of tasks to update 
	 */
	public static List<Task> completeTasks(Map<Id,Task> oldRecordsList, List<Task> newRecordsList){
		//Checks if the task has been complete, then modifies the status
		for(Task newTask : newRecordsList){
			Task oldTask = oldRecordsList.get(newTask.Id);
			if(newTask.Type == Label.FII_TaskType_Action && ((oldTask.FII_ACT_FLG_EmailPending__c == true && oldTask.FII_ACT_FLG_SMSPending__c == false && newTask.FII_ACT_FLG_EmailPending__c == false) || 
			(oldTask.FII_ACT_FLG_EmailPending__c == false && oldTask.FII_ACT_FLG_SMSPending__c == true && newTask.FII_ACT_FLG_SMSPending__c == false) || 
			(oldTask.FII_ACT_FLG_EmailPending__c == true && oldTask.FII_ACT_FLG_SMSPending__c == true && newTask.FII_ACT_FLG_EmailPending__c == false && newTask.FII_ACT_FLG_SMSPending__c == false))){
				newTask.Status = Label.FII_TaskStatus_Completed;
			}
            
            If( oldTask.Status == 'Open' && newTask.TV_Campana_Marcador__c != null && newTask.CallDurationInSeconds != null ){
                newTask.Status = Label.FII_TaskStatus_Completed;
            }
		}
		return newRecordsList;
	} 

	
	// START - everis (LHZ) - 2019/06/26 IBBA's 411 - 858 - 861 - 366
	public static void sendSurvey(Map<Id,Task> newTasks, Map<Id,Task> oldTasks){
		Map<Id,String> taskSurvey1 = new Map<Id,String>(); //Map Id Contacto al que actualizar el campo y String con 'CaseId;AccountId;ContactId'
	
		List<Id> listCaseId = new List<Id>(); //Lista Id Caso para traer los casos relacionados con la interacción
		Map<String,List<sObject>> listsObject = new Map<String,List<sObject>>();
		List<Case> listCaseToUpdate = new List<Case>();
		//Encuestas_Calidad_Percibida__c ecp = Encuestas_Calidad_Percibida__c.getOrgDefaults(); 

		for(Task newT : newTasks.values()){ 
			for(Task oldT : oldTasks.values()){
				if(newT.Id == oldT.Id //Si son la misma Task
					&& newT.RecordTypeId == IDRT_ACT_INTERACTION  // Si es de tipo Interaccion
					&& newT.FII_ACT_TXT_Main_interaction__c == null // Si es una interacción principal
					&& newT.FII_ACT_SEL_Interaction_Type__c == Label.FII_TaskInteractionType_Input //Si es de tipo entrada
					&& newT.Status != oldT.Status //Si el estado cambia
					&& newT.Status == Label.FII_TaskStatus_Completed){ // Si el estado cambia a completado
					if(newT.FII_ACT_TXT_CaseNeed__c == null ){ //Si no tiene necesidad relacionada
						//listCaseId.add(newT.FII_ACT_TXT_Recruitment_interaction__c); 
						taskSurvey1.put(newT.WhoId,';'+newT.FII_ACT_LKP_RelatedClient__c+';'+newT.WhoId);
						if(newT.FII_ACT_TXT_Recruitment_interaction__c == null){
							if(listsObject.get('1') == null){
								listsObject.put('1', new List<Task>{newT});
							} else {
								listsObject.get('1').add(newT);
							}
						}else{
							Id taskId = newT.FII_ACT_TXT_Recruitment_interaction__c;
							String sObjName = taskId.getSObjectType().getDescribe().getName();
							if(sObjName == 'Case'){
								Id parentId = [SELECT ParentId FROM Case WHERE Id =: newT.FII_ACT_TXT_Recruitment_interaction__c].ParentId;
								Case cParent = [SELECT Id, Status, ParentId, FII_CAS_TXT_Opened_Interaction__c,FII_CAS_TXT_Last_interaction__c, Contact.Role__c, Type, FII_CAS_SEL_Subtype__c, Origin, Account.Segment_of_Value__c, FII_CAS_TXT_LastChannelInteracts__c FROM Case WHERE Id =: parentId];
								if(cParent.Status == Label.FII_CaseStatus_Resolved){
									if(listsObject.get('2') == null){
										listsObject.put('2', new List<Case>{cParent});
									}else{
										listsObject.get('2').add(cParent);
									}
								}
							}else{
								Task actionTask = [SELECT Id, WhatId FROM Task WHERE Id =: newT.FII_ACT_TXT_Recruitment_interaction__c];
								Case cParent = [SELECT Id, Status, ParentId, FII_CAS_TXT_Opened_Interaction__c,FII_CAS_TXT_Last_interaction__c, Contact.Role__c, Type, FII_CAS_SEL_Subtype__c, Origin, Account.Segment_of_Value__c, FII_CAS_TXT_LastChannelInteracts__c FROM Case WHERE Id =: actionTask.WhatId];
								if(cParent.Status == Label.FII_CaseStatus_Resolved){
									if(listsObject.get('2') == null){
										listsObject.put('2', new List<Case>{cParent});
									}else{
										listsObject.get('2').add(cParent);
									}
								}
		
							}
						}

					} else { //Si tiene necesidad relacionada
						listCaseId.add(newT.FII_ACT_TXT_CASENEED__c);
					}
				}
                /*If( oldT.Status == 'Open' && newT.TV_Campana_Marcador__c != null && newT.CallDurationInSeconds != null ){
                	newT.Status = Label.FII_TaskStatus_Completed;
            	}*/
			}
		}
		if(!listCaseId.isEmpty()){
			
			for( Case c: [SELECT Id, Status, ParentId, FII_CAS_TXT_Opened_Interaction__c,FII_CAS_TXT_Last_interaction__c, Contact.Role__c, Type, FII_CAS_SEL_Subtype__c, Origin, Account.Segment_of_Value__c, FII_CAS_TXT_LastChannelInteracts__c FROM Case WHERE Id IN :listCaseId]){
				if( c.Status == Label.FII_CaseStatus_Resolved) { 
					if(listsObject.get('2') == null){
						listsObject.put('2', new List<Case>{c});
					}else{
						listsObject.get('2').add(c);
					}
				} 
				else {
					if(listsObject.get('1') == null){
						listsObject.put('1', new List<Task>{newTasks.get(c.FII_CAS_TXT_Opened_Interaction__c)});
					} else {
						listsObject.get('1').add(newTasks.get(c.FII_CAS_TXT_Opened_Interaction__c));
					}
				}
			}
		}

		Map<String,List<sObject>> objectsToUpdate = checkParametrics(listsObject);
		listCaseToUpdate = (List<Case>) objectsToUpdate.get('Case');
		if (Schema.sObjectType.Case.IsUpdateable()) {
			update listCaseToUpdate;
		}

	}
	// END - everis (LHZ) - 2019/06/26 IBBA's 411 - 858 - 861 - 366
	

	/************************
	 * OTHER PUBLIC METHODS *
	 ************************/

	/**
	 *  a
	 *
	 * @param
	 */
	public static List<SObject> mapApiNamePicklist(List<SObject> records){
		List<SObject> objList = new List<SObject>();

		// Map Case.Status
		Map<String,String> mapStatusCase = new Map<String,String>();
		Schema.DescribeFieldResult picklistStatusCase = Case.Status.getDescribe();
		List<Schema.PicklistEntry> ple = picklistStatusCase.getPicklistValues();
		for( Schema.PicklistEntry f : ple){
			mapStatusCase.put(f.getValue(),f.getLabel());
		}

		// Map Task.Status
		Map<String,String> mapStatusTask = new Map<String,String>();
		Schema.DescribeFieldResult picklistStatusTask = Task.Status.getDescribe();
		List<Schema.PicklistEntry> ple1 = picklistStatusTask.getPicklistValues();
		for( Schema.PicklistEntry f : ple1){
			mapStatusTask.put(f.getValue(),f.getLabel());
		}

		// Map Task.FII_ACT_SEL_Interaction_Type__c
		Map<String,String> mapTypeTask = new Map<String,String>();
		Schema.DescribeFieldResult picklistTypeTask= Task.FII_ACT_SEL_Interaction_Type__c.getDescribe();
		List<Schema.PicklistEntry> ple2 = picklistTypeTask.getPicklistValues();
		for( Schema.PicklistEntry f : ple2){
			mapTypeTask.put(f.getValue(),f.getLabel());
		}
		// Map Task.FII_ACT_SEL_Interaction_Category__c
		Map<String,String> mapCategoryTask = new Map<String,String>();
		Schema.DescribeFieldResult picklistCategoryTask = Task.FII_ACT_SEL_Interaction_Category__c.getDescribe();
		List<Schema.PicklistEntry> ple3 = picklistCategoryTask.getPicklistValues();
		for( Schema.PicklistEntry f : ple3){
			mapCategoryTask.put(f.getValue(),f.getLabel());
		}
		// Map Task.FII_ACT_SEL_Channel__c
		Map<String,String> mapChannelTask = new Map<String,String>();
		Schema.DescribeFieldResult picklistChannelTask = Task.FII_ACT_SEL_Channel__c.getDescribe();
		List<Schema.PicklistEntry> ple4 = picklistChannelTask.getPicklistValues();
		for( Schema.PicklistEntry f : ple4){
			mapChannelTask.put(f.getValue(),f.getLabel()); 
		}

		// Map NE__Quote__c.NE__Status__c
		Map<String,String> mapStatusQuote = new Map<String,String>();
		Schema.DescribeFieldResult picklistStatusQuote = NE__Quote__c.NE__Status__c.getDescribe();
		List<Schema.PicklistEntry> ple5 = picklistStatusQuote.getPicklistValues();
		for( Schema.PicklistEntry f : ple5){
			mapStatusQuote.put(f.getValue(),f.getLabel());
		}

 		Map<String,String> mapStatusOppty = new Map<String,String>();
		Schema.DescribeFieldResult picklistStatusOppty = Opportunity.StageName.getDescribe();
		List<Schema.PicklistEntry> ple6 = picklistStatusOppty.getPicklistValues();
		for( Schema.PicklistEntry f : ple6){
			mapStatusOppty.put(f.getValue(),f.getLabel());
		}
		for(SObject so : records){
			switch on String.valueOf(so.getSobjectType()){
				when 'Case' {
					Case c = (Case)so;
					c.Status = mapStatusCase.get(c.Status);
					c.FII_TXT_CompanyOwner__c = c.FII_TXT_CompanyOwner__c != null ? c.FII_TXT_CompanyOwner__c : '';
					objList.add(c);
				}
				when 'Task' {
					Task t = (Task)so;
					t.Status = mapStatusTask.get(t.Status);
					t.FII_ACT_SEL_Interaction_Type__c = t.FII_ACT_SEL_Interaction_Type__c + ':' + mapTypeTask.get(t.FII_ACT_SEL_Interaction_Type__c);
					t.FII_ACT_SEL_Interaction_Category__c = t.FII_ACT_SEL_Interaction_Category__c + ':' + mapCategoryTask.get(t.FII_ACT_SEL_Interaction_Category__c);
					t.FII_ACT_SEL_Channel__c = t.FII_ACT_SEL_Channel__c + ':' + mapChannelTask.get(t.FII_ACT_SEL_Channel__c);
					objList.add(t);
				}
				when 'NE__Quote__c' {
					NE__Quote__c q = (NE__Quote__c)so;
					q.NE__Status__c = mapStatusQuote.get(q.NE__Status__c);
					objList.add(q);
				}
				when 'Opportunity' {
					//modificar la oportunidad estado con api
					Opportunity o = (Opportunity) so;
					o.StageName = mapStatusOppty.get(o.StageName);
					objList.add(o); 
				}
			}
		}

		return objList;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static List<Id> getRelatedClientsOrLeads(List<SObject> recordsList){
		List<Id> relatedClients = new List<Id>();
		for(SObject record :recordsList){
			switch on String.valueOf(record.getSobjectType()){
				when 'Case' {
					final Case c = (Case)record;
					if(c.AccountId != null){
						relatedClients.add(c.AccountId);
					} else{
						relatedClients.add(c.Lead__c);
					}
				}
				when 'Task' {
					final Task t = (Task)record;
					if(t.FII_ACT_LKP_RelatedClient__c != null){
						relatedClients.add(t.FII_ACT_LKP_RelatedClient__c);
					} else{
						relatedClients.add(t.WhoId);
					}
				}
				when 'NE__Quote__c' {
					final NE__Quote__c q = (NE__Quote__c)record;
					relatedClients.add(q.NE__AccountId__c);
				}
				when 'Opportunity' {
					final Opportunity o = (Opportunity) record;
					if (o.AccountId != null){
						relatedClients.add(o.AccountId);
					} else {
						relatedClients.add(o.FI_OPP_LKP_Lead__c);
					}
				}
			}
		}
		
		return relatedClients;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static void setContact(Id interactionId, Id contactId){
		if(Schema.sObjectType.Task.isAccessible() && Schema.sObjectType.AccountContactRelation.isAccessible()){
			final List<Task> interactions = [SELECT Id, FII_ACT_LKP_RelatedClient__c, WhoId FROM Task WHERE Id = :interactionId];

			if(interactions.size()>0){
				Task interaction = interactions[0];
				interaction.WhoId = contactId;

				List<AccountContactRelation> acrs = [SELECT Roles FROM AccountContactRelation WHERE AccountId = :interaction.FII_ACT_LKP_RelatedClient__c AND ContactId = :contactId];
				String role = ''; 
				if(acrs.size()>0){
					role = acrs[0].Roles;
				}
				interaction.FII_ACT_TXT_Role__c = role;
				if(Schema.sObjectType.Task.isUpdateable()){
					update interaction;
				}
			}
		}
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static List<Task> createNewChildInteractions(List<SObject> objWithInteractionToCreate, Map<Id,List<Task>> interactionsInProgressMap){
		List<Task> interactionsToInsert = new List<Task>();
		for(SObject obj :objWithInteractionToCreate){
			final List<Task> interactionList = interactionsInProgressMap.get(getRelatedClientsOrLeads(new List<SObject>{obj})[0]);
			Task mainInteraction = null;
			for(Task t :interactionList){
				if(t.FII_ACT_TXT_Main_interaction__c == null){
					mainInteraction = t;
					break;
				}
			}
			Task childInte = new Task();
			// Fields of mainInteraction
			childInte.WhoId = mainInteraction.WhoId;
			childInte.FII_ACT_LKP_RelatedClient__c = mainInteraction.FII_ACT_LKP_RelatedClient__c;
			childInte.OwnerId = UserInfo.getUserId();
			childInte.Type = Label.FII_TaskType_Interaction;
			childInte.Subject = 'Child '+ mainInteraction.Subject;
			childInte.FII_ACT_SEL_Channel__c = mainInteraction.FII_ACT_SEL_Channel__c;
			childInte.FII_ACT_TXT_Main_interaction__c = mainInteraction.Id;
			childInte.RecordTypeId = IDRT_ACT_INTERACTION;

			// Fields to relate the actions or needs
			switch on String.valueOf(obj.getSobjectType()){
				when 'Case' {
					final Case c = (Case)obj;
					if(c.ParentId == null){ // It's a child interaction for a need
						childInte.FII_ACT_TXT_CaseNeed__c = c.Id;
						childInte.FII_ACT_TXT_CaseNeedType__c = c.Type;
						childInte.FII_ACT_TXT_RecIt_Name__c = c.CaseNumber;
						if(c.Lead__c != null){ // It's a Lead
							childInte.FII_ACT_LKP_WhatId__c = c.Id;
						} else{ // It's a Client
							childInte.WhatId = c.Id;
						}
					} else{ // It's a child interaction for an action
						childInte.FII_ACT_TXT_Recruitment_interaction__c = c.Id;
						childInte.FII_ACT_TXT_RecIt_Name__c = c.CaseNumber;
					}
				}
				when 'Task' {
					final Task t = (Task)obj;
					childInte.FII_ACT_TXT_Recruitment_interaction__c = t.Id;
					childInte.FII_ACT_TXT_RecIt_Name__c = t.FII_ACT_AUT_Identifier__c;
				}
				when 'NE__Quote__c' {
					final NE__Quote__c q = (NE__Quote__c)obj;
					childInte.FII_ACT_TXT_Recruitment_interaction__c = q.Id;
					childInte.FII_ACT_TXT_RecIt_Name__c = q.Name;
				}
				when 'Opportunity' {
					final Opportunity o = (Opportunity) obj;
					childInte.FII_ACT_TXT_Recruitment_interaction__c = o.Id;
					childInte.FII_ACT_TXT_RecIt_Name__c = o.Name;
				}
			}
			interactionsToInsert.add(childInte);
		}
		return interactionsToInsert;
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static List<Case> updateNeedStatus(List<Sobject> actionList, List<Case> casesToUpdate, List<Case> relatedNeeds){
		Map<Id,Case> casesToUpdateMap = new Map<Id,Case>();
		for(Case c :casesToUpdate){
			casesToUpdateMap.put(c.Id,c);
		}

		if(!actionList.isEmpty() && Schema.sObjectType.FII_Status_Priority__mdt.isAccessible()){
			final Integer CLOSED_PRIORITY = 500;
			Map<String, Integer> statusPriority = new Map<String, Integer>();
			Map<Integer, String> priorityMappedValue = new Map<Integer, String>();
			final List<FII_Status_Priority__mdt> statusPriorityList = new List<FII_Status_Priority__mdt>([
					SELECT FII_SP_Object__c, 
					FII_SP_Status__c, 
					FII_SP_Priority__c, 
					FII_SP_Mapped_Value__c,
					FII_SP_Closed__c
					FROM FII_Status_Priority__mdt]);
			
			for(FII_Status_Priority__mdt sp: statusPriorityList){
				statusPriority.put(sp.FII_SP_Object__c+sp.FII_SP_Status__c,sp.FII_SP_Priority__c.intValue());
				priorityMappedValue.put(sp.FII_SP_Priority__c.intValue(),sp.FII_SP_Mapped_Value__c);
			}
			Map<Id,Case> relatedNeedsMap = new Map<Id,Case>();
			List<Id> relatedNeedsId = new List<Id>();
			for(Case c : relatedNeeds){
				relatedNeedsMap.put(c.Id,c);
				relatedNeedsId.add(c.Id);
			}

			final Map<Id, Integer> minimumPriorityOfRelatedActionsMap = getMinimumPriorityOfRelatedActions(relatedNeedsId, statusPriority);
			for(SObject obj: actionList){
				Id needId;
				switch on String.valueOf(obj.getSobjectType()){
					when 'Case' {
						final Case c = (Case)obj;
						needId = c.ParentId;
					}
					when 'Task' {
						final Task t = (Task)obj;
						if(t.FII_ACT_LKP_WhatId__c != null){
							needId = t.FII_ACT_LKP_WhatId__c;
						} else{
							needId = t.WhatId;
						}
					}
					when 'NE__Quote__c' {
						final NE__Quote__c quote = (NE__Quote__c)obj;
						needId = quote.Case__c;
					}
					when 'Opportunity' {
						final Opportunity opp = (Opportunity) obj;
						needId = opp.FI_OPP_LKP_Case__c;
					}
				}
				
				if (needId == null || relatedNeedsMap.get(needId) == null) {
					continue;
				}
				
				// Tras la inserción/modificación de una actuación, el peso con el que se debería de quedar la necesidad (valor ya mapeado al estado de la necesidad)
				final Integer priorityOfRestrictiveAction = statusPriority.get('Case'+priorityMappedValue.get(minimumPriorityOfRelatedActionsMap.get(needId)));
				// Peso actual de la necesidad
				final Integer priorityOfNeed = statusPriority.get('Case'+relatedNeedsMap.get(needId).Status);

				String status;
				Datetime resolutionDate;
				Boolean updateStatus = false;
				Boolean updateResolutionDate = false;
				if(priorityOfRestrictiveAction < priorityOfNeed){
					resolutionDate = null;
					updateResolutionDate = true;
					status = priorityMappedValue.get(priorityOfRestrictiveAction);
					updateStatus = true;
				}else if(priorityOfRestrictiveAction == CLOSED_PRIORITY){
					resolutionDate = System.now();
					updateResolutionDate = true;
					if(priorityOfNeed < priorityOfRestrictiveAction){
						status = priorityMappedValue.get(priorityOfRestrictiveAction);
						updateStatus = true;
					}
				} else{ // priorityOfNeed < priorityOfRestrictiveAction
					status = priorityMappedValue.get(priorityOfRestrictiveAction);
					updateStatus = true;
				}

				if(updateStatus || updateResolutionDate){
					Case cAux = new Case();
					if(casesToUpdateMap.containsKey(needId)){
						cAux = casesToUpdateMap.get(needId);
						if(updateStatus){
							if(	cAux.Status != status){
								cAux.FII_CAS_FLG_EditedOnLayout__c = false;
								cAux.Status = status;
							}else{
								updateStatus = false;
							}
						}
						if(updateResolutionDate){
							cAux.FII_CAS_DAT_Resolution_Date__c = resolutionDate;
						}
						casesToUpdateMap.remove(needId);
						casesToUpdateMap.put(cAux.Id,cAux);
					} else{
						cAux = relatedNeedsMap.get(needId);
						if(updateStatus){
							if(	cAux.Status != status){
								cAux.FII_CAS_FLG_EditedOnLayout__c = false;
								cAux.Status = status;
							}else{
								updateStatus = false;
							}
						}
						if(updateResolutionDate){
							cAux.FII_CAS_DAT_Resolution_Date__c = resolutionDate;
						}
						casesToUpdateMap.put(cAux.Id,cAux);
					}
				}
			}
		}
		return casesToUpdateMap.values();
	}

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	public static List<Case> updateNeedType(List<Sobject> actionList, List<Case> casesToUpdate, List<Case> relatedNeeds){
		Map<Id,Case> casesToUpdateMap = new Map<Id,Case>();
		for(Case c :casesToUpdate){
			casesToUpdateMap.put(c.Id,c);
		}
		if(!actionList.isEmpty()){
			Map<Id,Case> relatedNeedsMap = new Map<Id,Case>();
			for(Case c : relatedNeeds){
				relatedNeedsMap.put(c.Id,c);
			}
			
			for(SObject obj: actionList){
				Id needId;
				String needType;
				Boolean updateType = false;
				switch on String.valueOf(obj.getSobjectType()){
					when 'Case' {
						Case c = (Case)obj;
						if(c.RecordTypeId == IDRT_CAS_CLAIM){
							needId = c.ParentId;
							if(needId != null){
								Case need = relatedNeedsMap.get(needId);
								if(need.Type == Label.FII_CaseType_AdministrativeManagement){
									updateType = true;
									needType = Label.FII_CaseType_Claim;
								}
							}
						}
					}
					when 'NE__Quote__c' {
						NE__Quote__c quote = (NE__Quote__c)obj;
						needId = quote.Case__c;
						if(needId != null){
							Case need = relatedNeedsMap.get(needId);
							if(need.Type != Label.FII_CaseType_Contract){
								updateType = true;
								needType = Label.FII_CaseType_Contract;
							}
						}
					}
				}
				if(updateType){
					Case cAux = new Case();
					if(casesToUpdateMap.containsKey(needId)){
						cAux = casesToUpdateMap.get(needId);
						cAux.Type = needType;
						casesToUpdateMap.remove(needId);
						casesToUpdateMap.put(cAux.Id,cAux);
					} else{
						cAux = relatedNeedsMap.get(needId);
						cAux.Type = needType;
						casesToUpdateMap.put(cAux.Id,cAux);
					}
				}
			}
		}
		return casesToUpdateMap.values();
	}
	
	/*******************
	 * PRIVATE METHODS *
	 *******************/

	/**
	 * Returns a
	 *
	 * @param
	 * @return
	 */
	private static Map<Id, Integer> getMinimumPriorityOfRelatedActions(List<Id> needIds, Map<String, Integer> statusPriority){
		final Map<Id, List<SObject>> relatedActionsMap = consultRelatedActionsBulk(needIds);
		Map<Id, Integer> minimumPriorityOfRelatedActionsMap = new Map<Id, Integer>();
		for(Id needId :needIds){
			final List<SObject> actionsList = relatedActionsMap.get(needId);
			List<Integer> statusList = new List<Integer>();
			List<Case> caseList = new List<Case>();
			List<Task> taskList = new List<Task>();
			List<Opportunity> opptyList = new List<Opportunity>();
			List<NE__Quote__c> quoteList = new List<NE__Quote__c>();
			for(SObject record :actionsList){
				switch on String.valueOf(record.getSobjectType()){
					when 'Case' {
						caseList.add((Case)record);
					}
					when 'Task' {
						taskList.add((Task)record);
					}
				   when 'NE__Quote__c' {
						quoteList.add((NE__Quote__c)record);
					}
					when 'Opportunity'{
						opptyList.add((Opportunity) record);
					}
				}
			}
			for(Case c : caseList){
				statusList.add(statusPriority.get(c.getSobjectType()+c.Status));
			}
			for(Task t : taskList) {
				statusList.add(statusPriority.get(t.getSobjectType()+t.Status));
			}
			for(NE__Quote__c q : quoteList){     
				statusList.add(statusPriority.get(q.getSobjectType()+q.NE__Status__c));                
			}
			for(Opportunity o : opptyList){
				statusList.add(statusPriority.get(o.getSobjectType()+o.StageName));
			}
			statusList.Sort();
			if (statusList.size() > 0){
				minimumPriorityOfRelatedActionsMap.put(needId, statusList.get(0));
			}
		}
		return minimumPriorityOfRelatedActionsMap;
	}

	
	private static Map<String, List<sObject>> checkParametrics(Map<String, List<sObject>> sObjectToCheck) {
		final List<Case> casesToUpdate = new List<Case>();
		final List<Task> tasksToUpdate = new List<Task>();

		if (Schema.sObjectType.FII_ParametricsSurveys__mdt.isAccessible()) {
			List<FII_ParametricsSurveys__mdt> psList = 
				[SELECT FII_PE_OriginChannel__c, 
						FII_PE_CI_1__c,
						FII_PE_CN_2__c,
						FII_PE_CN_3__c,
						FII_PE_MP_CI__c,
						FII_PE_MP_CN__c,
						FII_PE_SegmentOfValue__c,
						FII_PE_NeedType__c,
						FII_PE_TXT_ModelSurvey1__c,
						FII_PE_TXT_ModelSurvey2__c,
						FII_PE_TXT_ModelSurvey3__c
				FROM    FII_ParametricsSurveys__mdt 
				LIMIT   50];

			for (String key : sObjectToCheck.keySet()) {
				switch on key {
					when '1' {
						tasksToUpdate.addAll(checkParametricsTasks(psList, (List<Task>) sObjectToCheck.get(key)));
					}
					when '2', '3' {
						casesToUpdate.addAll(checkParametricsCases(psList, (List<Case>) sObjectToCheck.get(key), key));
					}
				}
			}
		}

		final Map<String, List<sObject>> mapResult = new Map<String, List<sObject>>();
		mapResult.put('Task', tasksToUpdate);
		mapResult.put('Case', casesToUpdate);

		return mapResult;
	}

	private static Set<Task> checkParametricsTasks(List<FII_ParametricsSurveys__mdt> psList, List<Task> taskList) {     
		final Set<Task> tasksToUpdate = new Set<Task>();

		if (Schema.sObjectType.Task.isAccessible()) {
			final Map<Id, Task> taskMap = new Map<Id, Task>([
				SELECT  Id, AccountId, Account.Segment_of_Value__c
				FROM    Task
				WHERE   Id IN :taskList
			]);

			for (Task myTask : taskList) {
				for(FII_ParametricsSurveys__mdt ps : psList) {
					final String segmentOfValue = taskMap.get(myTask.Id).Account.Segment_of_Value__c;

					// No se esta teniendo en cuenta por el momento el estado de la necesidad si es que existe una abierta asociada a la interaccion
					if (checkParametricsOrigin(myTask.FII_ACT_SEL_Channel__c, ps.FII_PE_OriginChannel__c) && checkParametricsSegment(segmentOfValue, ps.FII_PE_SegmentOfValue__c) && ps.FII_PE_CI_1__c) {
						myTask.FII_TSK_TXT_MediumPresentationCI__c = ps.FII_PE_MP_CI__c;
						myTask.FII_TSK_TXT_ModelSurvey__c = ps.FII_PE_TXT_ModelSurvey1__c;
						tasksToUpdate.add(myTask);
					}
				}
			}
		}

		return tasksToUpdate;
	}

	private static Set<Case> checkParametricsCases(List<FII_ParametricsSurveys__mdt> psList, List<Case> caseList, String type) {
		final Set<Case> casesToUpdate = new Set<Case>();

		for(Case myCase : caseList) {
			for(FII_ParametricsSurveys__mdt ps : psList){
				if (myCase.Contact.Role__c != 'House Manager' // Si no es administrador de fincas
				&&  myCase.Type == ps.FII_PE_NeedType__c //Si el tipo coincide
				&&  checkParametricsOrigin(myCase.FII_CAS_TXT_LastChannelInteracts__c, ps.FII_PE_OriginChannel__c)
				&&  checkParametricsSegment(myCase.Account.Segment_of_Value__c, ps.FII_PE_SegmentOfValue__c)) {
					
					if (type == '2' && ps.FII_PE_CN_2__c) {
						myCase.FII_CAS_TXT_MediumPresentationCN__c = ps.FII_PE_MP_CN__c;
						//c.FII_CAS_TXT_ModelSurvey__c = 'Modelo 2';
						myCase.FII_CAS_TXT_ModelSurvey__c = ps.FII_PE_TXT_ModelSurvey2__c;
						myCase.FII_FLG_SurveyAlreadySent__c = true;
						casesToUpdate.add(myCase);
					} 
					
					else if (type == '3' && ps.FII_PE_CN_3__c) {
						myCase.FII_CAS_TXT_MediumPresentationCN__c = ps.FII_PE_MP_CN__c;
						//c.FII_CAS_TXT_ModelSurvey__c = 'Modelo 2';
						myCase.FII_CAS_TXT_ModelSurvey__c = ps.FII_PE_TXT_ModelSurvey3__c;
						myCase.FII_FLG_SurveyAlreadySent__c = true;
						casesToUpdate.add(myCase);
					}
				}
			}
		}

		return casesToUpdate;
	}

	private static Boolean checkParametricsSegment(String objectSegment, String paramSegment) {
		return String.isEmpty(paramSegment) //Si esta vacio o
			|| (String.isNotEmpty(objectSegment) && objectSegment.containsAny(' ') && objectSegment.split(' ')[1] == paramSegment); //El segundo valor del segmento del cliente relacionado coincide
	}

	private static Boolean checkParametricsOrigin(String objectOrigin, String paramOrigin) {
		final Map<String, List<String>> origin = new Map<String, List<String>>();
		origin.put('CAT', new List<String>{'Phone'});
		origin.put('CCDD', new List<String>{'Email','Chat','Twitter','Facebook-Feed','Facebook-Worksheet','Facebook-Messenger','Chat APP',
			'Endesa Clientes','Website','Facebook','Instagram','YouTube','LinkedIn','SMS'});
		origin.put('CCPP', new List<String>{'CCPP'});

		//Si el origen pertenece a CAT ,CCDD o CCPP y está en la paramétrica
		for (String key : origin.keySet()) {
			if(origin.get(key).contains(objectOrigin) && key == paramOrigin) {
				return true;
			}
		}

		return false;
	}

	/*******************************
	 * TRIGGER OPPORTUNITY METHODS *
	 *******************************/

	/**
	 * Returns a ----------------------------------------------------> NEW ALEX
	 *
	 * @param
	 * @return
	 */
	public static Set<Id> getActionOpptyId(List<SObject> newRecordsList){
		// Set of new actions
		Set<Id> actionIds = new Set<Id>();
		for(Opportunity t: (List<Opportunity>)newRecordsList){
			actionIds.add(t.Id);
		}
		return actionIds;
	}
	
	/**
	 * Returns a --------------------------------------------------> ALEX
	 *
	 * @param
	 * @return
	 */
	public static Map<Id, Case> getRelatedOpptyNeeds(List<Opportunity> actionOptyList){
		Map<Id, Case> relatedNeedsMap = new Map<Id, Case>();
		if(Schema.sObjectType.Case.isAccessible()){
			// Set of identifiers of needs
			Set<Id> needsId = new Set<Id>();
			for(Opportunity o: actionOptyList){
				needsId.add(o.FI_OPP_LKP_Case__c);
			}
			// Map of needs
			relatedNeedsMap = new Map<Id, Case>([SELECT Id,
										Case_AccountName__c, 
										FII_CAS_TXT_Opened_interaction__c, 
										AccountId, 
										Origin, 
										OwnerId,
										ContactId, 
										Subject, 
										Status,
										FII_CAS_DAT_Resolution_Date__c,
										Type,
										CaseNumber,
										FII_CAS_FLG_RelatedWithInteraction__c,
										FII_CAS_NUM_RelatedInteractions__c,
										FII_CAS_TXT_LastChannelInteracts__c,
										Lead__c,
										FII_CAS_FLG_EditedOnLayout__c
										FROM Case WHERE Id IN :needsId]);
		}
		return relatedNeedsMap;
	}
	
	/**
	 * Returns a ----------------------------------------------------> NEW ALEX
	 *
	 * @param
	 * @return
	 */
	public static List<Opportunity> getActionOpptyList(Set<Id> actionOpptyId){
		// List of new actions
		List<Opportunity> actionList = new List<Opportunity>();
		if(Schema.sObjectType.Opportunity.isAccessible()){
			actionList = [SELECT Id, FI_OPP_LKP_Case__c, FI_OPP_LKP_Lead__c, AccountId, Name
							FROM Opportunity WHERE Id IN :actionOpptyId];
		}
		return actionList;
	}

	
	/**
	 * Returns a
	 *
	 * @param
	 * @param
	 * @return
	 */
	public static List<List<SObject>> actionsWithOpptyInteraction(List<Opportunity> actionOpptyList, Map<Id, List<Task>> interactionsInProgressMap, Map<Id, Case> relatedNeedsMap){
		List<List<SObject>> caseAndTasks = new List<List<SObject>>();
		List<Case> needCasesToUpdate = new List<Case>();
		List<Opportunity> actionsWithInteractionToCreate = new List<Opportunity>();
		List<Task> interactionsToUpdateRecId = new List<Task>();
		List<Opportunity> actToUpdateIntInfo = new List<Opportunity>();
		for(Opportunity action: actionOpptyList){
			final List<Task> interactionAndChilds = interactionsInProgressMap.get(getRelatedClientsOrLeads(new List<SObject>{action})[0]);
			Task t = null;
			if(interactionAndChilds != null){
				for(Task interaction :interactionAndChilds){
					if(interaction.FII_ACT_TXT_Main_interaction__c == null){
						t = interaction;
						break;
					}
				}
			}
			if(t != null){
				action.FI_OPP_TXT_Channel__c = t.FII_ACT_SEL_Channel__c;
				
				//action.FI_OPP_LKP_Lead__c =  t.WhoId;
				//No hay lookup a contact
				//action.WhoId = t.WhoId; //revieew case
				actToUpdateIntInfo.add(action);
				Case need = new Case();
				if(action.FI_OPP_LKP_Case__c != null){
					need = relatedNeedsMap.get(action.FI_OPP_LKP_Case__c);
				}

				if(need.FII_CAS_TXT_Opened_interaction__c == null){
					if(need.FII_CAS_NUM_RelatedInteractions__c != null){
						need.FII_CAS_NUM_RelatedInteractions__c = need.FII_CAS_NUM_RelatedInteractions__c + 1;
					} else{
						need.FII_CAS_NUM_RelatedInteractions__c = 1;
					}
					need.FII_CAS_TXT_Opened_interaction__c = t.Id;
					need.FII_CAS_TXT_Last_interaction__c = t.Id;
				}
				need.FII_CAS_TXT_LastChannelInteracts__c = action.FI_OPP_TXT_Channel__c;
				
				
				// If it is an interaction that is not yet related with an action
				if(t.FII_ACT_TXT_Recruitment_interaction__c == null){
					t.FII_ACT_TXT_Recruitment_interaction__c = action.Id;
					t.FII_ACT_TXT_RecIt_Name__c = action.Name; //Nombre actuacion relacionada
					if(!need.FII_CAS_FLG_RelatedWithInteraction__c){
						t.FII_ACT_NUM_POCaseNeed__c = 1;
						need.FII_CAS_FLG_RelatedWithInteraction__c= true;
					}
					interactionsToUpdateRecId.add(t);
				} else{
					Boolean createInteraction = true;
					// Comprobamos si existe una interacción hija relacionada con esta necesidad a la que podamos relacionar la actuación
					for(Task interaction :interactionAndChilds){
						if((interaction.WhatId == need.Id || interaction.FII_ACT_LKP_WhatId__c == need.Id) 
								&& interaction.FII_ACT_TXT_Main_interaction__c != null 
								&& interaction.FII_ACT_TXT_Recruitment_interaction__c == null){
							interaction.FII_ACT_TXT_Recruitment_interaction__c = action.Id;
							interaction.FII_ACT_TXT_RecIt_Name__c = action.Name;
							if(!need.FII_CAS_FLG_RelatedWithInteraction__c){
								interaction.FII_ACT_NUM_POCaseNeed__c = 1;
								need.FII_CAS_FLG_RelatedWithInteraction__c= true;
							}
							interactionsToUpdateRecId.add(interaction);
							createInteraction = false;
							break;
						}
					}
					if(createInteraction){
						actionsWithInteractionToCreate.add(action);
					}
				}
				needCasesToUpdate.add(need);
			}
		}
		caseAndTasks.add(needCasesToUpdate);
		caseAndTasks.add(actionsWithInteractionToCreate);
		caseAndTasks.add(interactionsToUpdateRecId);
		caseAndTasks.add(actToUpdateIntInfo);
		return caseAndTasks;
	}
}